<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_absolute_path;
 
/**
 * creates a form object to process the forms data
 * @param int form id
 * @param int table id
 * @param int row id
 */

function processForm( $formId, $tableId, $rowId ){
	global $database;
	josSpoofCheck();
	$oForm = new fabrikForm( $database );
	$oForm->load( $formId );
	$oForm->setAdmin( true );
	$oForm->processForm( $_POST, $tableId, $rowId, '' );
}

/**
 * cancels an edit operation
 */

function cancelForm( ){
	global $database;
	josSpoofCheck();
	$row = new fabrikForm( $database );
	$row->bind( $_POST );
	$row->checkin( );	
}

/**
 * creates the form, allowing the table view to add/edit forms
 * @param int formid
 * @param int row id 
 * @param int table id
 */
 
function showForm( $formId, $rowId, $tableId ){
	global $database;
	$oForm = new fabrikForm( $database );
	$oForm->load( $formId );
	$oForm->render( $tableId, $rowId, true, false, true );
}
		
/**
* Edit a form
* @param integer form id
* @param string message
*/

function editForm( $id = 0 ){
	//TODO : fabrik : 0.5 : get generic settings for emails etc and ensure these are entered as default
	global $database, $my, $mosConfig_absolute_path;
	$lists = array();
	$row = new fabrikForm( $database );
	$row->load( $id ); 
	if ( trim( $row->publish_down ) == '0000-00-00 00:00:00' ) {
		$row->publish_down = 'Never';
	}
	if ( isset( $row->checked_out )) { 
		// fail if checked out not by 'me'
		if ( $row->checked_out && $row->checked_out <> $my->id ) {
			mosRedirect("index2.php?option=com_fabrik&scope=$row->scope&mosmsg=The form $row->title is currently being edited by another administrator");
		} 
		if ( $id != "0" ) {
			$row->checkout($my->id);
		}
	}
	// get available elements to list as possible email receipt fields
	// $$$ hugh - added Joins and Username (which could be set to 'email') types to the list
	$sql = "SELECT element_name AS value, element_label as text 
	FROM #__fabrik_formgroup
	LEFT JOIN #__fabrik_elements ON #__fabrik_formgroup.group_id = #__fabrik_elements.group_id
	WHERE #__fabrik_formgroup.form_id = '$id'
	AND (elementtype_id = '2' or elementtype_id = '5' or elementtype_id = '12' or elementtype_id = '10')";

	$database->setQuery( $sql );
	$possible_email_receipt_fields = $database->loadObjectList();
	$possible_email_receipt_fields[] = mosHTML::makeOption('', _NONE);
	if (isset( $row->receipt_email )) {
	    $receipt_email = $row->receipt_email;
	} else {
		$receipt_email  = "";
	}
	if ($id != '0') {
		$lists['email_receipt_list'] = mosHTML::selectList($possible_email_receipt_fields , 'receipt_email', 'class="inputbox" size="1"', 'value', 'text', $receipt_email );
	} else {
		$lists['email_receipt_list'] = _EMAILRECEIPT_AFTER_SAVE;
	}
	$database->setQuery( "SELECT  id AS value,  CONCAT_WS(': ', name,  email) as text FROM #__users" );
	$users = $database->loadObjectList();
	if (isset( $row->action_id )) {
	    $action_id = intval( $row->action_id );
	} else {
		$action_id = 0;
	}
	$lists['userslist'] = mosHTML::selectList( $users, 'action_id', 'class="inputbox" size="1"', 'value', 'text', $action_id );
	// get a list of used groups
	$sql = "SELECT  #__fabrik_formgroup.group_id AS value,  
		#__fabrik_groups.group_name AS text
		FROM #__fabrik_formgroup 
		LEFT JOIN #__fabrik_groups 
		ON #__fabrik_formgroup.group_id = #__fabrik_groups.id
		WHERE  #__fabrik_formgroup.form_id = '$id' 
		AND #__fabrik_groups.group_name <> ''
		ORDER BY  #__fabrik_formgroup.ordering";
	$database->setQuery( $sql );
	$current_groups = $database->loadObjectList( );
	$lists['current_grouplist'] = mosHTML::selectList( $current_groups, 'current_groups', "class=\"inputbox\" style=\"width:170px;\" size=\"10\" ", 'value', 'text', '/' );
	// get a list of available groups - need to make the sql only return groups not already listed in mos_fabrik_fromgroup for $id
	$sql = "SELECT id AS value,  group_name AS text FROM #__fabrik_groups ";
	$i = 0;
	foreach( $current_groups as $cg ){
		if ( $i == 0 ) {
		    $sql .= " WHERE ";
		} else {
			$sql .= " AND ";
		}
		$val = $cg->value;
		$sql .= " id <> '$val'";
		$i++;
	} 
	$database->setQuery( $sql );
	$groups = $database->loadObjectList( );
	$lists['grouplist'] = mosHTML::selectList( $groups, 'groups', "class=\"inputbox\" size=\"10\" style=\"width:170px;\" ", 'value', 'text', null ); 	
	// make a list of alignment options
	$align_options = array( mosHTML::makeOption('left', 'left'), mosHTML::makeOption('center', 'center'), mosHTML::makeOption('right', 'right') );
	$lists['align'] = mosHTML::selectList( $align_options, 'align', "class=\"inputbox\" size=\"1\" ", 'value', 'text', $row->align );
	$tabs = new mosTabs( 1 );
	$lists['menuselect'] = mosAdminMenus :: MenuSelect();
	$and = "\n AND link LIKE 'index.php?option=com_fabrik&act=viewForm&fabrik=".$row->id."'";
	$and2 = "\n AND link LIKE 'index.php?option=com_fabrik' and params like '%fabrik=".$row->id."%'";
	$menus = mosAdminMenus::Links2Menu( 'url', $and );
	$menus2 = mosAdminMenus::Links2Menu( 'components', $and2 );
	$menus = array_merge( $menus , $menus2 );
	if ($row->id == '') { 
		// this is a new form so fill in some default values
		$row->reset_button_label = _RESET;
		$row->submit_button_label = _SUBMIT;
		$row->width = '100%';
	}	
	//	get the view only templates
	$templates = fabrikListDirs( $mosConfig_absolute_path. "/components/com_fabrik/views/form/tmpl/" );
	foreach ($templates as $file) {
		$oTemplates[] = mosHTML::makeOption( $file );
	}	
	$row->view_only_template == '' ? $viewTemplate = "default" : $viewTemplate = $row->view_only_template;
	$lists['viewOnlyTemplates'] = mosHTML::selectList( $oTemplates, 'view_only_template', 'class="inputbox"', 'value', 'text', $viewTemplate );
	//get the form templates
	$oTemplates = array( );
	//$templates =  mosReadDirectory( $mosConfig_absolute_path . "/components/com_fabrik/tmpl/form", "" );
	foreach ( $templates as $file ) {
		if ( substr( $file, strlen($file)-4, strlen($file))  != ".css" ) {
			$oTemplates[] = mosHTML::makeOption( $file );
		}
	}
	$row->form_template == '' ? $formTemplate = "default" : $formTemplate = $row->form_template;
	$lists['formTemplates'] = mosHTML::selectList($oTemplates, 'form_template', 'class="inputbox"', 'value', 'text', $formTemplate );
	
	// build list of users
	$active = (intval( $row->created_by ) ? intval( $row->created_by ) : $my->id);
	$lists['created_by'] = mosAdminMenus::UserSelect('created_by', $active);
	$params = new fabrikParams( $row->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/form.xml', 'component' );
	
	//get the email templates
	$oTemplates = array( );
	$oTemplates[] = mosHTML::makeOption( '', _DEFAULT );
	$templates =  mosReadDirectory( $mosConfig_absolute_path . "/components/com_fabrik/views/email", "" );
	foreach ( $templates as $file ) {
		if($file != 'index.html'){
			if ( substr( $file, strlen($file)-4, strlen($file))  != ".css" ) {
				$oTemplates[] = mosHTML::makeOption( $file );
			}
		}
	}
	$lists['emailTemplates'] = mosHTML::selectList( $oTemplates, 'params[email_template]', 'class="inputbox"','value','text',$params->get('email_template'));
	
	$msg = mosGetParam( $_GET, 'msg', '' );
	html_form_content::editForms( $row, $tabs, $lists, $menus, $params, $msg );
} 

/**
* Save the form
* @return int form id 
*/

function saveForm( $aData ){
	global $database, $my;
	josSpoofCheck();
	$oForm = new fabrikForm( $database );
	$oForm->save( $aData );
	return $oForm->id; 
}

/**
* copy a form
* @param array of form ids to copy
*/

function copyForm( $cid ){
	global $database;
	josSpoofCheck();
	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		echo "<script> alert('Select an item to move'); window.history.go(-1);</script>\n";
		exit;
	}
	foreach( $cid as $id ){
		$oForm = new fabrikForm( $database );	
		$oForm->load( $id );
		$oNewForm = new fabrikForm( $database );
		$oNewForm->copyRow( $id );
		//copy the groups for the newly created form
		$groups = $oForm->getGroups( );
		$oNewForm->setGroups( $groups );
	}
}

/**
* Display all the available forms
* @param string message
*/

function displayForms( $msg='' ){
	global $database, $mainframe, $mosConfig_offset, $mosConfig_absolute_path;
	$filter_form = $mainframe->getUserStateFromRequest( "filter_form", 'filter_form', '' );
	// get the total number of records
	$sql = "SELECT count(*) FROM #__fabrik_forms ";
	if ( $filter_form != '' ) {
		$where[] = " form_title like '%$filter_form%' ";
	}
	$sWhere = '';
	if ( !empty ( $where ) ) {
		$sWhere .= " WHERE ".implode(' AND ', $where);
		$sql = $sql . $sWhere;
	}	
	$database->setQuery( $sql );
	$total = $database->loadResult( );
	echo $database->getErrorMsg( );
	$limit = intval( mosGetParam( $_POST, 'limit', 10 ) );
	$limitstart = intval( mosGetParam( $_POST, 'limitstart', 0 ) );
	$sql = "SELECT *, u.name AS editor, #__fabrik_forms.id AS id FROM #__fabrik_forms " .
			"LEFT JOIN #__users AS u ON u.id = #__fabrik_forms.checked_out " .
			"$sWhere " .
			"LIMIT $limitstart, $limit";
	$database->setQuery( $sql );
	require_once( $mosConfig_absolute_path . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );
	$rows = $database->loadObjectList( );
	if ( $database->getErrorNum( ) ) {
		echo $database->stderr( );
		return false;
	}
	$lists['filter_form'] =  '<input type="field" value="' . $filter_form . '" name="filter_form" onblur="document.adminForm.submit( );" />';
	html_form_content::showForms( $rows, $pageNav, $msg, $lists );
} 

/**
* Delete a form
* @param aray form id integers to delete
*/

function deleteForm( $cid ){
	global $database;
	josSpoofCheck();
	$msg = '';
	for ( $i = 0, $n = count($cid); $i < $n; $i++ ) {
		$sql = "DELETE FROM #__fabrik_forms WHERE id = '" . $cid[$i] . "'";
		$database->setQuery( $sql );
		if ( !$database->query( ) ) {
			$msg .= $database->getErrorMsg() . "\n";
		} 
		$sql = "DROP TABLE #__fabrik_formdata_" . $cid[$i] ;
		$database->setQuery( $sql );
		// TODO : fabrik : 0.5 : ask if the user wants to delete database table
		if ( !$database->query( ) ) {
			$msg .= $database->getErrorMsg( ) . "\n";
		} 
	} 
} 

/**
* Create a menu item for the form
* @param integer form id
*/

function createfabrikMenu( &$form_id ){
	global $database, $mosConfig_absolute_path;
	$menu = new mosMenu( $database );
	$menu->type = 'url';
	$menu->link = 'index.php?option=com_fabrik&task=viewForm&fabrik=' . $form_id;
	$menu->menutype = 'mainmenu';
	$menu->browserNav = 0;
	$menu->ordering = 9999;
	$menu->parent = 0;
	if ( !$menu->store( ) ) {
		echo "<script> alert('" . $menu->getError() . "'); window.history.go(-1); </script>\n";
		exit( );
	} 
	$cid = array( );
	$cid[ 0 ] = $menu->id;
	$menutype = 'mainmenu';
	$option = 'com_menus';
	$task = 'edit';
	$type= 'url'; 
	//rob: fix for 4.5.2
	$menu->updateOrder( "menutype='$menu->menutype' AND parent='$menu->parent'" );
	require( "$mosConfig_absolute_path/administrator/components/com_menus/url/url.menu.php" );
}

/**
 * publish/unpublish a form
 * @param array/int form to set publish state
 * @param bol publish on/off
 */

function publishForm( $id, $state ) {
	global $database;
	josSpoofCheck();
	$oForm = new fabrikForm( $database );
	$oForm->publish( $id, $state );
}

