<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrik_html_content {

	/**
	 * get javascript actions to attach to element
	 * @param array javascript actions
	 * @param int element id
	 * @return string javascript actions to attach to element
	 */
	 
	function getJavascript( $jsActions, $elId ){
		$js = "";
		if (!empty( $jsActions[$elId] )) {
			$aJs = $jsActions[$elId];
			foreach ( $aJs as $aJsObjs ) {
				$action = $aJsObjs->action;
				$code = $aJsObjs->code;
				$js .= $action . " = \"" .  $code . "\" ";
			}
		}
		return $js;
	}

	/**
	 * once the form has been sucessfully completed, and if no jump page is
	 * specified then show the thanks message
	 * @param string thanks message title
	 * @param string thanks message string
	 */
	 
	function displayThanks( $title, $message) {
		global $mosConfig_absolute_path;
		require_once( $mosConfig_absolute_path . "/includes/HTML_toolbar.php" );
		?>
    <div class="componentheading"> <?php echo $title ?></div>
    <p><?php echo html_entity_decode( $message ) ?></p>
    <?php
	}
	
	/**
	 * once email has been sent to a frind show this message 
	 */
	 
	 function emailSent( $to, $template='' ){
	 	global $mosConfig_sitename, $mainframe;
		$mainframe->setPageTitle( $mosConfig_sitename );
		addHeadTag( '<link rel="stylesheet" href="templates/'. $template .'/css/template_css.css" type="text/css" />' );
		?>
		<span class="contentheading"><?php echo _EMAIL_SENT." $to";?></span><br />
		<br />
		<br />
		<a href='javascript:window.close();'>
		<span class="small"><?php echo _PROMPT_CLOSE;?></span>
		</a>
		<?php
	 }
	 
	/**
	 * show form to allow users to email form to a friend
	 * @param object form
	 */
	function emailForm( $oForm, $template='' ){
		global $mosConfig_sitename, $mainframe, $mosConfig_db;
		$mainframe->setPageTitle( $oForm->form_title );
		$userTask = mosGetParam($_GET, 'userTask', '');
		$rowId = mosGetParam($_GET, 'rowId', '');
		addHeadTag( '<link rel="stylesheet" href="templates/'. $template .'/css/template_css.css" type="text/css" />' );
		?>
		<form method="post" action="index2.php?option=com_fabrik&amp;task=sendEmail" name="frontendForm">
			<table>
				<tr>
					<td>
						<label for="email"><?php echo _EMAIL_FRIEND_ADDR; ?></label>
					</td>
					<td>
						<input type="text" size="25" name="email" id="email"/>
					</td>
				</tr>
				<tr>
					<td>
						<label for="yourname"><?php echo _EMAIL_YOUR_NAME; ?></label>
					</td>
					<td>
						<input type="text" size="25" name="yourname" id="yourname"/>
					</td>
				</tr>
				<tr>
					<td>
						<label for="youremail"><?php echo _EMAIL_YOUR_MAIL; ?></label>
					</td>
					<td>
						<input type="text" size="25" name="youremail" id="youremail"/>
					</td>
				</tr>
				<tr>
					<td>
						<label for="subject"><?php echo _SUBJECT_PROMPT; ?></label>
					</td>
					<td>
						<input type="text" size="40" maxlength="40" name="subject" id="subject"/>
					</td>
				</tr>
				<tr>
					<td colspan="2">
					<input type="submit" name="submit" class="button" value="<?php echo _BUTTON_SUBMIT_MAIL; ?>" />
					&nbsp;&nbsp;
					<input type="button" name="cancel" value="<?php echo _BUTTON_CANCEL; ?>" class="button" onclick="window.close();" />
					</td>
				</tr>
			</table>
			<input type="hidden" name="fabrik" value="<?php echo $oForm->id;?>" />
			<input type="hidden" name="userTask" value="<?php echo $userTask;?>" />
			<input type="hidden" name="rowId" value="<?php echo $rowId;?>" />
			<input type="hidden" name="<?php echo mosHash( $mosConfig_db );?>" value="1" />
		</form>
		<?php
	}
	
	/**
	 * writes out a pdf icon
	 * @param object form
	 * @param object parameters
	 * @param int row id
	 * @return string pdf html icon/link
	 */
	 
	function pdfIcon( $oForm, $params, $rowId ){
		global $mosConfig_live_site;
		if ( $params->get( 'pdf' ) && !$params->get( 'popup' ) ) {
			$status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no';
			$link = $mosConfig_live_site ."/index2.php?option=com_fabrik&amp;do_mf_pdf=1&amp;task=viewTableRowDetails&amp;fabrik=". $oForm->id . "&amp;tableid=" . $oForm->table_id . "&amp;rowid=" . $rowId;
			if ( $params->get( 'icons' ) ) {
				$image = mosAdminMenus::ImageCheck( 'pdf_button.png', '/images/M_images/', NULL, NULL, _CMN_PDF, _CMN_PDF );
			} else {
				$image = _CMN_PDF .'&nbsp;';
			}
			return "
			<a href='javascript:void(0)' onclick=\"window.open('$link','win2','$status');;return false\" title='" . _CMN_PDF . "'>"
			. $image .
			"</a>";
		}		
	}
	
	/**
	 * writes a print icon
	 * @param object form
	 * @param object parameters
	 * @param int row id
	 * @return string print html icon/link
	 */
	 
	 function printIcon( $oForm, $params, $rowid = '' ){
		global $mosConfig_live_site;
		if ( $params->get( 'print' ) ) {
			$status = "status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=400,height=250,directories=no,location=no";
			$link = $mosConfig_live_site ."/index2.php?option=com_fabrik&amp;pop=1&amp;task=viewTableRowDetails&amp;fabrik=". $oForm->id . "&amp;tableid=" . $oForm->table_id . "&amp;rowid=" . $rowid;
			// $$$ hugh
			if ($this_layout = mosGetParam($_REQUEST,'layout','')) {
				$link .= '&amp;layout=' . $this_layout;
			}
			if ( $params->get( 'icons' ) ) {
				$image = mosAdminMenus::ImageCheck( 'printButton.png', '/images/M_images/', NULL, NULL, _CMN_PRINT, _CMN_PRINT );
			} else {
				$image = '&nbsp;'. _CMN_PRINT;
			}
			if ( $params->get( 'popup', 1 ) ){
				$ahref = '<a href="javascript:void(0)" onclick="javascript:window.print(); return false" title="' . _CMN_PRINT . '">';	
			} else {
				$ahref = "<a href='#' onclick=\"window.open('$link','win2','$status;');return false;\"  title='" .  _CMN_PRINT . "'>";
			}
			$return = $ahref .
			$image .
			"</a>";
			return $return;
		}	 		
	 }
	
	/**
	* Writes Email icon
	* @param object form
	* @param object parameters
	* @return string email icon/link html
	*/
	
	function emailIcon( &$oForm, &$params ) {
		global $mosConfig_live_site;
		$task = mosGetParam($_REQUEST, 'task', 'viewTableRowDetails');
		$rowId = mosGetParam($_REQUEST, 'rowid', '');
		$popup = $params->get( 'popup', 1 );
		if ( $params->get( 'email' ) && !$popup ) {
			$status = "status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=400,height=250,directories=no,location=no";
			$link = $mosConfig_live_site ."/index2.php?option=com_fabrik&amp;task=emailForm&amp;fabrik=". $oForm->id . "&amp;userTask=$task&amp;rowId=$rowId";
			if ( $params->get( 'icons' ) ) {
				$image = mosAdminMenus::ImageCheck( 'emailButton.png', '/images/M_images/', NULL, NULL, _CMN_EMAIL, _CMN_EMAIL );
			} else {
				$image = '&nbsp;'. _CMN_EMAIL;
			}
			return "<a href='#' onclick=\"window.open('$link','win2','$status;');return false;\"  title='" .  _CMN_EMAIL . "'>
			$image
			</a>";
		}
	}
	
	/**
	 * get any html errror messages for form element
	 * @param string parsed element name
	 * @param array error messages
	 * @param int group element type
	 * @return string error messages
	 */
	 
	function getErrorMsg( $parsed_name, $arErrors, $groupeltype ){
		$err_msg = '';
		$parsed_name = str_replace('[]', '', $parsed_name);
		if (isset ($arErrors[$parsed_name])) {
			if(is_array($arErrors[$parsed_name])){
				foreach ($arErrors[$parsed_name] as $el_err_msg) {
					$err_msg .= "$el_err_msg<br/>";
				}
			}
		}
		if ($groupeltype == '8') { // file upload element has extra error messages 
			if (isset ($arErrors['ul_userfile'])) {
				foreach ($arErrors['ul_userfile'] as $el_err_msg) {
					$err_msg .= "$el_err_msg<br/>";
				}
			}
		}		
		return $err_msg;
	}				 
	
	/**
	 * wrapper for getLabel for backwards compat with non template form display DONT THINK ITS USED ANYMORE
	 * @param object element
	 * @param string class name
	 * @param bol include <label> tag for element label
	 * @param int id of labels form element
	 * @param object element parameters
	 */

	function drawLabel( &$oElement, $class='fabrikLabel', $bLabel=false, &$params ){
		fabrik_html_content::getLabel($oElement, $class='fabrikLabel', $bLabel=false, $params);
	}
				
	/**
	 * writes the label for the form element
	 * @param object element
	 * @param string class name
	 * @param bol include <label> tag for element label
	 * @param object element parameters
	 * @return string html label
	 */
	function getLabel( &$oForm, &$oElement, $class='fabrikLabel', $bLabel=false, &$params,  $elementHTMLId='' ){
		global $mosConfig_lang, $mosConfig_mbf_content, $database, $mosConfig_live_site, $Itemid, $mainframe, $my;
		$elementid = "mf_el_" . $elementHTMLId;
		$str = '';
		$task = mosGetParam($_REQUEST, 'task', '');
		if(! $oElement->canView( )){
			return '';
		}
		if( $task == 'viewForm' && ! $oElement->canUse()){
			return '';
		}
		$str .= "<div class=\"$class";
		if(isset($oElement->_aValidations) && $oElement->canUse()){
			if ( count( $oElement->_aValidations ) > 0 ) {
				foreach( $oElement->_aValidations as $oValidation ){
					$vid = $oValidation->validation_rule_id;
					if ( array_key_exists( $vid, $oForm->_validationRuleClasses ) ) {
						$str .= " " . $oForm->_validationRuleClasses[$vid];
					}
				}
			}
		}
		$str .= "\" id=\"$elementid" . "_text\">";
		if ( $bLabel ){
			$str .= "<label for=\"$elementHTMLId\">";
		}
		$label = $oElement->element_label;
		
		//posssible solution to mamblefish traslation bug????:
    if ((false) && (class_exists('MambelFish'))) {
      $label = MambelFish::translate( $oElement, 'fabrik_elements', $mosConfig_lang );
    }
		//check to see if the text should be eval'd 
		if ($class != 'fabrikLabel') {
			if ($oElement->eval == "1") {
				$label = eval( fabrik_html_content::prepareEvalText( $oElement->element_label ) );
			}
		}
		$rollOver = str_replace( "'", "\'", $params->get( 'rollover' ));
		$rollOver = str_replace( '"', '\"', $rollOver );
		$rollOver = str_replace( '\\', '\\\\', $rollOver );

		$hoverTitle = str_replace( "'", "\'", $params->get( 'hover_text_title', 'Hover text' ));
		$hoverTitle = str_replace( '"', '\"', $hoverTitle );
		$hoverTitle = str_replace( '\\', '\\\\', $hoverTitle );
		
		if ($rollOver != '') {
			$str .= "<span class=\"editlinktip\"><span onmouseover=\"return overlib(('$rollOver'), CAPTION, '$hoverTitle', BELOW, RIGHT);\" onmouseout=\"return nd();\">$label</span></span>";
		} else {
			$str .= $label;
		}
		if ( $bLabel ){
			$str .= "</label>";
		}
		$str .= "</div>\n";
		return $str;	
	}
		
	/**
	 * prepares eval text, removing unwanted br tags, and quotes
	 * @param string text to prepare
	 * @return prepared text
	 */
	 
	 function prepareEvalText( $txt ){
	 	$txt = str_replace(array('<br>', '<br />'), '', $txt);
		$txt = html_entity_decode($txt);		
		return $txt;			
	 }

	/**
	 * draws the database drop down element
	 * @param array list of db drop downs in the form
	 * @param array form data
	 * @param object current element
	 * @param object groups current group
	 * param int repeat group counter
	 * @return string html for database join element
	 */

	function drawDbDropDown( &$lists, &$data, &$oElement, &$oGroup, $repeatCounter = 0 ) {
		$editable 		 = $oElement->_editable;
		$elementHTMLName = $oElement->_htmlName;
		$elementHTMLId   = $oElement->_elementHTMLId;
		$js				 = $oElement->_js;
		$str 			 = '';
		
		$bit = (!$editable || !$oElement->canUse() ) ? 'default' :  'dropdown';

		if ($oElement->hidden == '1') {
			return fabrik_html_content::drawField( $oElement, $data, true );
		}
		//@TODO:  test this with repeat groups - added line below as normal groups with repeat group turned on was not working
		$key = str_replace("join___" . $oGroup->join_id . "___", "", $elementHTMLId);
		if(!array_key_exists($key, $lists)){
			$key = 	str_replace( '[]', '', $elementHTMLName );
		}
		if (isset( $lists[$key] )) {
			//$parsed_name .= $elsuffix;
			//comented the above out - not sure if its needed to duplicate groups, might need to do a str_replace with the dd
			$str 	 = $lists[$key][$bit][$repeatCounter];
			//$default = $lists[$elementHTMLName]['default'][$repeatCounter];
		} else {
			if (isset( $lists['join'] )) {
				$joinData = $lists['join'][$oGroup->join_id];
				// $$$ hugh - changed to use 'join[' instead of 'join' otherwise screws element names with the word 'join' in them!
				$joinSearch = str_replace('join[', '[', $elementHTMLName);
				$joinSearch = str_replace( array('[' .$oGroup->join_id .']', ']', '[') , '', $joinSearch);
				if (array_key_exists( $joinSearch, $joinData )) {
					$str = ($joinData[$joinSearch][$bit][$repeatCounter]);	
				}
			}
		}
		//put in the id
		$strReplace = "<select $js id=\"$elementHTMLId\"";
		$str = preg_replace("/(<select)/", $strReplace, $str );
		return $str;
	}

	/**
	 * draws a field element
	 * @param object element
	 * @param array data to preopulate element with
	 * @param bol ignore the size setting for the element (used to write hidden text areas when user has no access rights to the element)
	 * @return mixed returns field element if echo = false, else returns nothing
	 */
	 
	function drawField( $oElement, $data, $ignoreSizeSettings= false ) {
		$size 			 = $oElement->element_width;
		$maxlength  	 = $oElement->maxlength;
		$params			=& $oElement->loadParams();
		$elementHTMLId   = $oElement->_elementHTMLId;
		$js				 = $oElement->_js;
		$elementHTMLName = $oElement->_htmlName;
		if ($maxlength == "0" or $maxlength == "") {
			$maxlength = $size;
		}
	
		$value = $oElement->default;

		$type = ( $oElement->password == "1" ) ? "password" : "text";
		$class = $type;
		if (isset($oElement->_elementError) && $oElement->_elementError != '') {
			$class .= " elementErrorHighlight";
		}
		if ($oElement->hidden == '1') {
			$type = "hidden";
		}
		$sizeInfo = ( $ignoreSizeSettings )? "" : " size=\"$size\" maxlength=\"$maxlength\"";
		//dont use stripslashes() as htmlspecialchars already run on default data
		if(!$oElement->_editable) {
			if( $oElement->hidden == '1' ) {
				return "<!--" . $value . "-->";
			} else {
				// $$$ rob added inteligent link creation to read only version of element
				if ($oElement->_params->get('guess_linktype') == '1') {
					if (fabrikForm::check_email_address( $value )) {
						$value = mosHTML::emailCloaking( $value );
					}
					if (stristr( $value, 'http' )) {
						$value = "<a href='$value'>$value</a>";
					} else {
						if (stristr($value, 'www.' )) {
							$value = "<a href='http://$value'>$value</a>";
						}
					}
				}
				
				$format = $params->get( 'text_format_string' );
				if ($format  != '') {
					$value =  sprintf( $format, $value );
				}
				return $value;
			}
		}
		
		
		$disabled = $oElement->_params->get('disable') ? "disabled=\"disabled\"" : "";
		$readonly = $oElement->_params->get('readonly') ? "readonly=\"readonly\"" : "";
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName );
		// no need to eval here as its done before hand i think !
		if ($oElement->eval == "1" and !isset ( $data[$elementHTMLName] )) {
			$str = "<input $disabled $readonly class=\"inputbox $type\" $js type=\"$type\" name=\"$elementHTMLName\" id=\"$elementHTMLId\" $sizeInfo value=\"$value\" />\n";
		} else {
			$str = "<input $disabled $readonly class=\"inputbox $class\" $js type=\"$type\" name=\"$elementHTMLName\" $sizeInfo id=\"$elementHTMLId\" value=\"$value\" />\n";
		}
		return $str;
	}
		
	/**
	 * draws a URL element
	 * @param object element
	 * @param array data to preopulate element with
	 * @param bol ignore the size setting for the element (used to write hidden text areas when user has no access rights to the element)
	 */
	 
	function drawURL( $oElement, $data, $ignoreSizeSettings= false ) {
		$size 			 = $oElement->element_width;
		$elementHTMLId   = $oElement->_elementHTMLId;
		$elementHTMLName = $oElement->_htmlName;
		$js 			 = $oElement->_js;
		$maxlength = $oElement->maxlength;
		if ($maxlength == "0" or $maxlength == "") {
			$maxlength = $size;
		}
		$value = $oElement->default;
		
		$sizeInfo = ($ignoreSizeSettings) ? "" : " size=\"$size\" maxlength=\"$maxlength\"";

		if ($value == "") {
			$value = array('label'=>'', 'link'=>'', 'delimiter'=>'//..*..//');
		} else {
			if (!is_array( $value )) {
				$tmpvalue = explode( "//..*..//", $value );
				$value = array();
				$value['label']=$tmpvalue[0];
				if (count( $tmpvalue ) > 1) {
					$value['link']=$tmpvalue[1];
				} else {
					$value['link']=$tmpvalue[0];
				}
				$value['delimiter']= isset($tmpvalue[2]) ? $tmpvalue[2] : '|';
			}
		}
		if( count( $value ) == 0 ){
			$value = array('label'=>'', 'link'=>'', 'delimiter'=>'//..*..//');
		}
		// $$$ hugh - added link_target
		$value['link_target'] = $oElement->_params->get('link_target', '_self');
		if( !$oElement->_editable ){
			$str = "<a href='" . $value['link']. "' target='" . $value['link_target'] . "'>"  . $value['label'] . "</a>";
			return $str;
		}
		
		$errorCSS  = '';
		if( isset($oElement->_elementError) && $oElement->_elementError != '' ){
			$errorCSS = " elementErrorHighlight";
		}
		
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName);
		$str = "Label:<br />";
		$str .= "<input class=\"inputbox$errorCSS\" $js  name=\"$elementHTMLName" . "[label]\" $sizeInfo id=\"$elementHTMLId\" value=\"" . stripslashes(urldecode($value['label'])) . "\" />\n";
		$str .= "<br />URL:<br />";
		$str .= "<input class=\"inputbox$errorCSS\" $js  name=\"$elementHTMLName" . "[link]\" $sizeInfo id=\"$elementHTMLId" . "_link\" value=\"" . stripslashes(urldecode($value['link'])) . "\" />\n";
		$str .="<input type='hidden' name='$elementHTMLName" . "[delimiter]' value='|' />";
		return $str;
	}		

	/**
	 * write a series of checkbox items
	 * @param object element
	 * @param array data to preopulate check box with
	 */

	function drawCheckBox( &$oElement, $data ) {
		$editable 	   = $oElement->_editable;
		$elementHTMLId = $oElement->_elementHTMLId;
		$params 	   = $oElement->_params;
		$js 		   = $oElement->_js;
		$elementHTMLName = $oElement->_htmlName;
		$str = '';
		$arVals = split("\|", $oElement->dd_values);
		$arTxt = split("\|", $oElement->dd_text);
		$arSelected = array ();
		$arSelected = split("\|", $oElement->dd_intial_selection);

		// ROB - for checkbox the default data contains any posted data from form that 
		// fails validation.
		if ($oElement->default != '') {
		  $arSelected = explode( "//..*..//", $oElement->default );
		}
		if (!is_array( $arSelected )) {
			$arSelected = array();
		}
		
		$str .= "<div id='$elementHTMLId'>\n";
		$aRoValues = array();
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName );
		$options_per_row = $params->get( 'options_per_row', '4' );
		//avoid extraneous td's if checkboxes less than one row long
		if ($options_per_row > count( $arVals )) {
			$options_per_row = count( $arVals );
		}
		$option_width = round(100 / $options_per_row);
		$opr = 0;
		$str .= "   <div style=\"display:table; align=left; width:100%; border-spacing:5px\">\n";
		for ($ii = 0; $ii < count($arVals); $ii ++) {
			$thisId = $elementHTMLId."_".$ii;
			if ($opr == 0) {
				$str .= "      <div style=\"display: table-row; width:auto\">\n";
			}
			if (in_array( $arVals[$ii], $arSelected )) {	
				$aRoValues[] = $arTxt[$ii];
				if ($params->get( 'element_before_label' )  == '1') { 
					$str .= "         <div style=\"width: {$option_width}%; display: table-cell; float:left\"><input type=\"checkbox\" class=\"checkbox\" $js name=\"$elementHTMLName"."[]"."\" value=\"$arVals[$ii]\" id=\"$thisId\" checked=\"checked\" />&nbsp;<label for='$thisId'>$arTxt[$ii]</label></div>\n";
				} else {
					$str .= "         <div style=\"width: {$option_width}%; display: table-cell; float:left; text-align: right\"><label for='$thisId'>$arTxt[$ii]</label>&nbsp;<input type=\"checkbox\" class=\"checkbox\" $js name=\"$elementHTMLName"."[]"."\" value=\"$arVals[$ii]\" id=\"$thisId\" checked=\"checked\" /></div>\n";
				}
			} else {
				if ($params->get( 'element_before_label' )  == '1') {
					$str .= "         <div style=\"width: {$option_width}%; display: table-cell; float:left;\"><input type=\"checkbox\" class=\"checkbox\" $js name=\"$elementHTMLName"."[]"."\" value=\"$arVals[$ii]\" id=\"$thisId\" />&nbsp;<label for='$thisId'>$arTxt[$ii]</label></div>\n";
				} else {
					$str .= "         <div style=\"width: {$option_width}%; display: table-cell; float:left; text-align: right\"><label for='$thisId'>$arTxt[$ii]</label>&nbsp;<input type=\"checkbox\" class=\"checkbox\" $js name=\"$elementHTMLName"."[]"."\" value=\"$arVals[$ii]\" id=\"$thisId\" /></div>\n";
				}
			}
			if (++$opr == $options_per_row) {
				$str .= "      </div>\n";
				$opr = 0;
			}
		}
		if ($opr != 0) {
			$str .= "      </div>\n";
		}
		$str .= "   </div>\n";
		$str .= "</div>\n";
		$str .= "<br style=\"clear: both\" />\n";
		if (!$editable) {
			return implode( ',', $aRoValues );
		}
		return $str;
	}

	/**
	 * draw a series or radion buttongs
	 * @param object element
	 * @param array data to preopulate check box with
	 * @param array list of error messages
	 */

	function drawRadioButton( $oElement, $data ) {
		$elementHTMLId = $oElement->_elementHTMLId;
		$params 	   = $oElement->_params;
		$elementHTMLName = $oElement->_htmlName;
		$js 		= $oElement->_js;
		$arVals 	= split("\|", $oElement->dd_values);
		$arTxt 		= split("\|", $oElement->dd_text);
		$arSelected = split("\|", $oElement->dd_intial_selection );
		if ( isset ($data[$oElement->element_name] ) ) {
			if( !is_array($data[$oElement->element_name] ) ){
				$arSelected = explode(',', $data[$oElement->element_name]);
			} else {
				$arSelected = $data[$oElement->element_name];
			}
		}else{
			if (isset ($data[$elementHTMLName])) {
				if(!is_array($data[$elementHTMLName])){
					$arSelected = explode(',', $data[$elementHTMLName]);
				}else{
					$arSelected = $data[$elementHTMLName];
				}
			}
		}
		$str = "";
		$aRoValues = array();
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName);
		$radio_options_per_row = (int) $params->get( 'radio_options_per_row', '4' );
		$opr = 0;
		$str .= "<table>";
		for ($ii = 0; $ii < count($arVals); $ii ++) {
			$thisId = $elementHTMLId."_".$ii;
			if ($opr == 0) {
				$str .= '<tr>';
			}
			if (in_array($arVals[$ii], $arSelected)) {
				$aRoValues[] = $arTxt[$ii];
				if($params->get( 'radio_element_before_label' )  == '1'){
					$str .= "<td><label><input type=\"radio\" $js name=\"$elementHTMLName\" value=\"$arVals[$ii]\" id=\"$thisId\" checked=\"checked\" />$arTxt[$ii]</label></td>\n";
				}else{
					$str .= "<td><label>$arTxt[$ii]<input type=\"radio\" $js name=\"$elementHTMLName\" value=\"$arVals[$ii]\" id=\"$thisId\" checked=\"checked\" /></label></td>\n";
				}
			} else {
				if($params->get( 'radio_element_before_label' )  == '1'){
					$str .= "<td><label><input type=\"radio\" $js name=\"$elementHTMLName\" value=\"$arVals[$ii]\" id=\"$thisId\" />$arTxt[$ii]</label></td>\n";
				}else{
					$str .= "<td><label>$arTxt[$ii]<input type=\"radio\" $js name=\"$elementHTMLName\" value=\"$arVals[$ii]\" id=\"$thisId\" /></label></td>\n";
				}
			}
			if (++$opr >= $radio_options_per_row) {
				$str .= "</tr>";
				$opr = 0;
			}
		}
		if(!$oElement->_editable){
			return implode(',', $aRoValues);
		}
		if ($opr != 0) {
			for ($ii = $opr; $ii < $radio_options_per_row; $ii ++) {
				$str .= "<td>&nbsp;</td>";
			}
			$str .= '</tr>';
		}
		$str .= "</table>";
		return $str;
	}
		
	/**
	 * draws a text area
	 * @param object element
	 * @param array data to fill in text area with
	 */

	function drawTextArea( $oElement, $data ) {
		$elementHTMLId = $oElement->_elementHTMLId;
		$elementHTMLName = $oElement->_htmlName;
		$js = $oElement->_js;
		$params =& $oElement->loadParams();
		if ($oElement->hidden == '1') {
			return fabrik_html_content::drawField( $oElement, $data, true );
		}
		
		$use_wysiwyg = $oElement->use_wysiwyg;
		$cols = $oElement->element_width;
		$rows = $oElement->element_height;
		$value = $oElement->default;
		if (array_key_exists( $oElement->element_name, $data )) {
			// $$$ if we have a validation failure from a module/bot,
			// data is going to be an array, so pick out the value
			if (is_array($data[$oElement->element_name])) {
				$value = $data[$oElement->element_name]['value'];
			}
			else {
				$value = $data[$oElement->element_name];
			}
		} else {
			if (array_key_exists( $elementHTMLName, $data )) {
				if (is_array($data[$elementHTMLName])) {
					$value = $data[$elementHTMLName]['value'];
				}
				else {
					$value = $data[$elementHTMLName];
				}
			}
		}
		//think the data is now sanitized before getting here
		//$value = stripslashes(urldecode($value));
		
		$errorCSS  = '';
		if (isset( $oElement->_elementError ) && $oElement->_elementError != '') {
			$errorCSS = " elementErrorHighlight";
		}
		
		$str = "";
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName );
		
		if (!$oElement->_editable) {
			return $value;
		}
		
		if ($use_wysiwyg) {
			$str .= fabrik_html_content::getEditorArea($elementHTMLName, $value, $elementHTMLName, '100%', '200', $cols, $rows);
		} else {
			$str .= "<textarea $js class=\"inputbox$errorCSS\" name=\"$elementHTMLName\" id=\"$elementHTMLId\" cols=\"$cols\" rows=\"$rows\">".$value."</textarea>\n";
		}
		
		if ($params->get( 'textarea-showmax' )) {
			$charsLeft = $oElement->maxlength - strlen($value);
			$str .= "<div class='fabrik_characters_left'><span id='$elementHTMLId" . "_counter'>" . $charsLeft . "</span> " . _CHARACTERS_LEFT . "</div>";
		}
		return $str;
	}

	/**
	 * hack to get the editior code without it being written out to the page straight away
	 * think this returns a simple text field
	 */
	function getEditorArea( $name, $content, $hiddenField,$width, $height, $col, $row ){
		global $mainframe, $_MAMBOTS, $my, $mosConfig_editor, $my;
		if (!defined( '_FABRIK_EDITOR_INCLUDED' )) {
			$mainframe->set( 'loadEditor', true );
			if ($mosConfig_editor == '') {
				$mosConfig_editor = 'none';
			}
			$editor = $mosConfig_editor;
			if ( $my->id != '0' ) {
				// Per User Editor selection
				$params = new mosParameters( $my->params );
				$editor = $params->get( 'editor', '' );
			}
			
			$editor = $mosConfig_editor;
			$_MAMBOTS->loadBot( 'editors', $editor, 1 );
			$_MAMBOTS->loadBotGroup( 'editors-xtd' );

			define( '_FABRIK_EDITOR_INCLUDED', 1 );	
			$results = $_MAMBOTS->trigger( 'onInitEditor' );
			foreach ($results as $result) {
				if (trim($result)) {
				   echo $result;
				}
			}
		}

		$results = $_MAMBOTS->trigger( 'onEditorArea', array( $name, $content, $hiddenField, $width, $height, $col, $row ) );
		foreach ($results as $result) {
			if (trim($result)) {
				return $result;
			}
		}
		
		// ensure editor-xtd bots are loaded only once
		if (!defined( '_JOS_EDITORXTD_INCLUDED' )) {
			define( '_JOS_EDITORXTD_INCLUDED', 1 );
			$_MAMBOTS->loadBotGroup( 'editors-xtd' );
		}
		
		//$mainframe->set( 'loadEditor', true );

		$results = $_MAMBOTS->trigger( 'onEditorArea', array( $name, $content, $hiddenField, $width, $height, $col, $row ) );
		foreach ($results as $result) {
			if (trim($result)) {
				return $result;
			}
		}
	}
	
	function getEditorContents( $editorArea, $hiddenField ) {
		global $mainframe, $_MAMBOTS;

		$mainframe->set( 'loadEditor', true );

		$results = $_MAMBOTS->trigger( 'onGetEditorContents', array( $editorArea, $hiddenField ) );
		foreach ($results as $result) {
			if (trim($result)) {
				return $result;
			}
		}
	}
		
	/**
	 * draw a standard dropdown select list
	 * @param object element
	 * @param array prepopulate with data from this 
	 */
		 
	function drawDropDown( $oElement, $data ) {
		$elementHTMLId   = $oElement->_elementHTMLId;
		$elementHTMLName = $oElement->_htmlName;
		$params 	     = $oElement->_params;
		$js = $oElement->_js;
		$allowAdd 	= $params->get( 'allow_frontend_addtodropdown', false );
		$editable 	= $oElement->_editable;
		$vals 		= $oElement->dd_values;
		$txt 		= $oElement->dd_text;
		$multiple 	= $oElement->multiple;
		$fullName = str_replace( '[]', '', $elementHTMLName );
		$aPossiblekeys = array( $fullName, $oElement->element_name );
		$found = false;
		foreach ($aPossiblekeys as $n) {
			if (isset( $data[$n] ) && $data[$n] != '') {
				$found = true;
				$aInitialValues = $data[$n];
				//check if its from a form//
				if (is_array( $aInitialValues )) {
					if (array_key_exists( 'value', $aInitialValues )) {
						if (is_array( $aInitialValues['value'] )) {
							$atmp = array();
							foreach ($aInitialValues['value'] as $trueval) {
								$atmp[] = $trueval;
							}
							$aInitialValues = $atmp;
						}
					}
				} else {
					if ($multiple == "1") {
						$aInitialValues = explode( "//..*..//", $aInitialValues );
					}
				}
			}
		}
		if (!$found) {
			$aInitialValues = explode( '|',$oElement->dd_intial_selection );
			
		}
		if (is_string( $aInitialValues )) { 
			//always ensure initial vals are in an array
			$aInitialValues = array($aInitialValues);
		}
		
		array_walk( $aInitialValues, 'trim' );
		$arVals 	= split("\|", $vals);
		$arTxt 		= split("\|", $txt);
		
		
		$errorCSS  = '';
		if (isset( $oElement->_elementError ) &&  $oElement->_elementError != '') {
			$errorCSS = " elementErrorHighlight";
		}
		
		$str = "<select class=\"inputbox$errorCSS\" $js ";
		if ($multiple == "1") {
			$elementHTMLName .= "[]"; //add this in to allow for multiple selections //
			$str .= " multiple=\"multiple\" ";
		}
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName );
		$str .= " name=\"$elementHTMLName\" id=\"$elementHTMLId\" ";
		$str .= ">\n";
		$i = 0;
		$aRoValues = array();
		
		foreach ($arVals as $tmpval) {
			$tmptxt = addslashes(htmlspecialchars($arTxt[$i]));
			$str .= "<option value=\"$tmpval\" ";
			if (in_array( $tmpval, $aInitialValues )) {
				$aRoValues[] = $tmptxt;
				$aRoVals[] = $tmpval;
				$str .= "selected=\"selected\" ";
			}
			$str .= ">$tmptxt</option>\n";
			$i ++;
		}
		$str .= "</select>\n";
		if (!$editable) {
			$iconFolder = $params->get('icon_folder', '');
			if ($iconFolder) {
				global $mosConfig_absolute_path;
				for ($ro = 0; $ro < count($aRoValues); $ro++) {
					$roVal = $aRoVals[$ro];
					$file = $mosConfig_absolute_path . '/images/stories/' . $iconFolder . '/' .$roVal . '.png';
					if (file_exists( $file )) {
						$aRoValues[$ro] = "<img src=\"images/stories/$iconFolder/$roVal.png\" alt=\"$roVal\" />";
					}
				}
			}
			return implode(',', $aRoValues);
		}
		if ($allowAdd) {
			$elementHTMLId_ddVal = $elementHTMLId . "_ddVal";
			$elementHTMLId_ddLabel = $elementHTMLId . "_ddLabel";
			$str .= "<a onclick=\"\$('$elementHTMLId" . "_addForm').toggle();return false;\" href='#'>[+]</a>" .
					"<div id=\"$elementHTMLId" . "_addForm\" style='display:none'>" .
					"<table><tr><td>" .
					_ADDELEMENT_SUBELEMENT_VALUE . "</td><td>" .
					"<input id='$elementHTMLId_ddVal' name='addDropDownValue' /></td></tr>" .
					"<tr><td>" .
					_ADDELEMENT_SUBELEMENT_TEXT . "</td>" .
					"<td><input id='$elementHTMLId_ddLabel' name='addDropDownLabel' /></td></tr>" .
					"<tr><td colspan='2'><input id=\"$elementHTMLId" . "_addFormButton\" type='button' value='add' name='submit' /></td></tr>" .
					"</table></div>
					<input type='hidden' name='$elementHTMLId" . "_newValueList' id='$elementHTMLId" . "_newValueList' />
					<input type='hidden' name='$elementHTMLId" . "_newLabelList' id='$elementHTMLId" . "_newLabelList' />
					<script type='text/javascript'>
					$('$elementHTMLId" . "_addFormButton').addEvent( 'click', function(e){
						var v = \$('$elementHTMLId_ddVal').getValue();
						var l = \$('$elementHTMLId_ddLabel').getValue();
						$('$elementHTMLId" . "_newValueList').value = \$('$elementHTMLId" . "_newValueList').getValue() + '|' + v;
						$('$elementHTMLId" . "_newLabelList').value = \$('$elementHTMLId" . "_newLabelList').getValue() + '|' + l;
						var opt = new Element('option', {'value': v}).appendText(l);
						opt.injectInside(\$('$elementHTMLId'));
					});
					</script>";
		}
		return $str;
	}

	function drawText( $oElement, $data ) {
		// $$$ hugh - added $data as arg so eval'ed text can get it
		if ($oElement->eval == "1" ) {
			return eval( $oElement->element_label );
		} else {
			return $oElement->element_label;
		}
	}

	/**
	 * creates the upload file elements
	 * @param object upload element to draw
	 * @param array existing data
	 * @param int counter for upload field
	 * @param int row id
	 */

	function drawFileUpload( $oElement, $data, $uploadCount = '1', $rowId = '' ) {
		global $mosConfig_live_site, $mosConfig_absolute_path, $fabrikConfig;
		$elementHTMLId 	 = $oElement->_elementHTMLId;
		$elementHTMLName = $oElement->_htmlName;
		$js 			 = $oElement->_js;
		$params 	     = $oElement->_params;
		if ($oElement->hidden == '1') {
			fabrik_html_content::drawField( $oElement, $data, true );
			return;
		}			
		
		$str = "";
		if( array_key_exists( $elementHTMLName, $data) ){
			
			// $$$ hugh - reworked this section so it shows link to non-image
			if( $data[$elementHTMLName] != '' ) {
				// $$$ hugh - path vs URI
				// for some reason, some Upload data is paths, some are URL's
				// this was being handled in the table code, but not here.  So
				// I copped the following from replaceDataWithIcons
				$absFile = $data[$elementHTMLName];
				//returing from a validation
				if( is_array( $absFile )) {
					$absFile = $absFile['value'];
				}
				if( !strstr( $absFile, 'http://' ) ){
					$absFile = str_replace('\\', '/' , $absFile);
					if( !strstr( $absFile, $mosConfig_absolute_path ) ){
						$absFile = $mosConfig_absolute_path . '/' . $oElement->ul_directory . '/' . $data[$elementHTMLName];
					}
					$file = str_replace( $mosConfig_absolute_path, $mosConfig_live_site, $absFile );
				}
				//returing from a validation
				if (is_array( $data[$elementHTMLName] )) {
					$data[$elementHTMLName] = $data[$elementHTMLName]['value'];
				}
				//$$$ rob trim the forwardslahes to ensure correct test
				if(strstr($data[$elementHTMLName], rtrim($mosConfig_live_site, '/') . '/' . trim($oElement->ul_directory, '/') . '/')){
					$file = $data[$elementHTMLName];
				}else{
					/* ensure the live site and upload direcotry are included 
					$$$ rob again tidy up the src*/
					$file = rtrim($mosConfig_live_site, '/') . '/' . trim($oElement->ul_directory, '/') . '/' . $data[$elementHTMLName];
				}
				
				if( $params->get( 'show_image' ) ){
					// $$$ hugh - slimbox stuff
					
					if( $params->get( 'make_thumbnail' )  == '1' ){
						$ofile = $file;
						$file = str_replace( $oElement->ul_directory, $params->get('thumb_dir'), $file);
						$f = basename($file);
						$dir = dirname($file);
						$file = $dir . '/' . $params->get('thumb_prefix') . $f;
						if ($fabrikConfig->fbConf_use_highslide) {
							$str =	"<a href='$ofile' class='highslide' onclick='return hs.expand(this)'><img src='$file' alt='$oElement->element_label' /></a><br />";								
						}
						else {
							$str =	"<a href='$ofile' rel='lightbox'><img src='$file' alt='$oElement->element_label' /></a><br />";
						}
					}
					else {
						$w = $params->get( 'image_max_width' );
						$h = $params->get( 'image_max_height' );
						switch( array_pop(explode('.',$file)) ){
							case 'mp3':
								$str = "<embed src=\"$file\" type=\"application/x-mplayer2\" autostart=\"false\" playcount=\"true\" loop=\"false\" height=\"50\" width=\"200\">";
								break;
							case 'mp4':
							case 'mov':
								
								$str = "<object width=\"$w\" height=\"$h\"
								classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\"
								codebase=\"http://www.apple.com/qtactivex/qtplugin.cab\">
								<param name=\"src\" value=\"$file\">
								<param name=\"autoplay\" value=\"false\">
								<param name=\"controller\" value=\"true\">
								<embed src=\"$file\" width=\"$w\" height=\"$h\"
								autoplay=\"false\" controller=\"true\"
								pluginspage=\"http://www.apple.com/quicktime/download/\">
								</embed>
								
								</object>";
								break;
							case 'swf':
								
								$str = "<object width=\"$w\" height=\"$h\">
							<param name=\"movie\" value=\"$file\">
							<embed src=\"$file\" width=\"$w\" height=\"$h\">
							</embed>
							</object>";
								break;
							default:
								$str =	"<img src='$file' alt='$oElement->element_label' /><br />";
								break;
						}
					}
				}
				else {
					$bits = explode( "/", $file );
					$filename = array_pop( $bits );
					$str = "<a href='" . $file . "'>" .$filename . "</a><br />";
				}
			}
		}
		if (!$oElement->_editable) {
			if (isset( $data[$elementHTMLName] )) {
				return $str;
			}
			return '';
		}
		if (isset( $_FILES[$elementHTMLName]['name'] )) {
			$value = $_FILES[$elementHTMLName]['name'];
		} else {
			$value = $oElement->default;
		}
		//repeat group names - testing as el[id][] rather than el[][id]
		if (strstr( $elementHTMLName, "[]" )) {
		  $idElName = rtrim( $elementHTMLName, "[]") . "[id][]";
		  //$ulidElName = rtrim( $elementHTMLName, "[]") . "[ul_id][]";
		  $valElName = rtrim( $elementHTMLName, "[]") . "[value][]";
		  $enddirElName = rtrim( $elementHTMLName, "[]") . "[ul_end_dir][]";
		} else {
		   $idElName = $elementHTMLName . "[id]";
		   //$ulidElName = $elementHTMLName . "[ul_id]";
		   $valElName = $elementHTMLName . "[value]";
		   $enddirElName = $elementHTMLName . "[ul_end_dir]";
		}
		$str .= '<input type="hidden" name="'.$idElName.'" value="'.$oElement->id.'" />'."\n";
		//$str .= '<input type="hidden" name="'.$ulidElName.'" value="'.$oElement->id.'" />'."\n";
		$str .= '<input type="hidden" name="'.$valElName.'" value="'.$value.'" />'."\n";
		if ($params->get('upload_allow_folderselect') == '1') {
			$rDir = $mosConfig_absolute_path . "/" .  $oElement->ul_directory;
			$images = array( );
			$folders = array( );
				
			$oElement->ReadImages( $rDir, "/", $folders, $images, array() );
			$folderOpts = array();
			if (is_array( $folders )) {
				foreach ($folders as $oDir) {
					$dir = $oDir->value;
					$newFolderopt = str_replace( $rDir, '', $dir );
					$folderOpts[] = mosHTML::makeOption( $newFolderopt );
				}
			}
			if (!empty( $folderOpts )) {
				$folderList = mosHTML::selectList( $folderOpts, $enddirElName, ' class="inputbox" size="1" ', 'value', 'text' );
				$str .= $folderList . "<br />";
			}
		}
		$str .= '<input name="'.$elementHTMLName.'" value="'.$value.'" ' . $js . ' type="file" id="'.$elementHTMLId.'" />'."\n";
		if ($params->get('show_upload_limit')) { 
			$postkb 	= str_replace("M", "", ini_get('post_max_size')) * 1000;
			$uploadkb = str_replace("M", "", ini_get('upload_max_filesize')) * 1000;
			if ($uploadkb < $postkb) {
				$postkb = $uploadkb;
			}
			$max = ( $postkb > $oElement->ul_max_file_size ) ? $oElement->ul_max_file_size : 	$postkb;
			$max = $max / 1000 . "M";
			$str .= "<br />". _UPLOAD_LIMIT . " = " . $max ;
		} 
		$str = '<table><tr><td>' . $str . '</td></tr></table>'; // hugh - maintains alignment in non-table templates
		return $str;
	}

	/**
	 * add an image to the form
	 * @param object element
	 * @param array data
	 * @param array errors
	 */
	 
	function drawImage( $oElement, $data ) {
		global $mosConfig_absolute_path, $mosConfig_live_site, $_VERSION, $fabrikConfig;
		$params 	= $oElement->_params;
		$elementHTMLName = $oElement->_htmlName;
		$canSelect 		= $params->get( 'image_front_end_select', '0' );
		$js						= $oElement->_js;
		$align 				= $oElement->image_float;
		$elementid 		= $oElement->getHTMLId();
		$imgElementId = $elementid . "_img";
		// $$$ hugh - root_folder is already / terminated
		// $rootDir 	=  $params->get( 'selectImage_root_folder', '/images' ) . '/';
		$rootDir 	=  $params->get( 'selectImage_root_folder', '/images/' );
		$style = ($align != "none" and $align != "") ?  "style=\"float:$align;\"" : $style = "";
		if (isset( $data[$elementHTMLName] )) {
			// $$$ hugh - fix Select Folder stuff
			$data[$elementHTMLName] = str_replace( '- Select Folder -', $rootDir, $data[$elementHTMLName] );
			if (!strstr( $data[$elementHTMLName],$rootDir )) {
				$data[$elementHTMLName] = $rootDir . $data[$elementHTMLName];
			}
			// $$$ end hugh
			$oElement->image_name = $data[$elementHTMLName];
		}
		// $$$ hugh - trying to fix double slash problem
		$src =  $mosConfig_live_site . '/images/stories/' . ltrim($oElement->image_name,"/");
		if ( $oElement->link_url != "" ) {
			$str = "<a href=\"".$oElement->link_url." \" target=\"_blank\" />";
			$str .= '<img '.$style . ' ' . $js .' src="' . $src . '" alt="'.$oElement->image_name.'" id="' . $imgElementId . '"/>'."\n";
			$str .= "</a>";
		} else {
			if (array_pop(explode('.',$oElement->image_name)) == 'mp3') {
				$str = "<embed src=\"$src\" type=\"application/x-mplayer2\" autostart=\"true\" playcount=\"true\" loop=\"false\" height=\"50\" width=\"200\">";
			}
			else {
				// $$$ hugh - slimbox stuff
				// This wierd bit of code basically looks to see if there is a file of the same name,
				// one directory level up.  If so, it will assume that the selected image was a thumbnail,
				// that the file one level up is the full size image, and create a lightbox link.
				// TODO check for some obvious thumb_ type prefix.
				// TODO functionize this, as we use it from several places
				if (preg_match('#~/#',$oElement->image_name)) {
					$src_dir = $mosConfig_absolute_path . '/images/stories' . $oElement->image_name;					
				} else {
					$src_dir = $mosConfig_absolute_path . '/images/stories/' . $oElement->image_name;
				}
				$src_dir_array = explode('/',$src_dir);
				$src_fname = array_pop($src_dir_array);
				array_pop($src_dir_array);
				array_push($src_dir_array,$src_fname);
				$maybe_src = implode('/',$src_dir_array);
				if (file_exists($maybe_src)) {
					$imgLinkElementId = $elementid . "_imglink";
					$maybe_link = str_replace( $mosConfig_absolute_path, $mosConfig_live_site, $maybe_src );
					if ($fabrikConfig->fbConf_use_highslide) {
						$str = '<a id="' . $imgLinkElementId . '" href="' . $maybe_link . '" class="highslide" onclick="return hs.expand(this)">';
					}
					else {
						$str = '<a id="' . $imgLinkElementId . '" href="' . $maybe_link . '" rel="lightbox[]">';
					}
					$str .= '<img '.$style. ' ' . $js .' src="' . $src . '" alt="'.$oElement->image_name.'" id="' . $imgElementId . '" />';
					$str .= '</a>' . "\n";
				}
				else {
					$str = ('<img '.$style. ' ' . $js .' src="' . $src . '" alt="'.$oElement->image_name.'" id="' . $imgElementId . '" />'."\n");
				}
			}
			// $$$ end hugh
		}
		// $$$ rob set default $imgToShowInDd val
		$imgToShowInDd = '';	
		if($canSelect && $oElement->_editable ){
			if($style==''){
				$str .="<br />";
			}else{
				$str .="<br style=\"clear:both\"/>";
			}
			$imgPathToShowInDd = '';
			$folderPathToShow = '';
			if(isset($data[$elementHTMLName])){
				$data[$elementHTMLName] = urldecode($data[$elementHTMLName]);
				// $$$ hugh this doesn't work if $rootDir is '/', 'cos then it just strips all
				// $$$ the slashes out!!  So lets test for that.
				if ($rootDir != '/') {
					$imgPathToShowInDd = str_replace( $rootDir, '', $data[$elementHTMLName]);
				}
				else {
					$imgPathToShowInDd = $data[$elementHTMLName];
				}
				$aTmp = explode('/', $imgPathToShowInDd);
				for($x = 0; $x < count($aTmp)-1; $x++){
					if(trim($aTmp[$x]) != ''){
						$folderPathToShow .= '/' . $aTmp[$x];
					}
				}
				$folderPathToShow .= '/';
				// $$$ hugh - grab image name
				$imgToShowInDd = array_pop($aTmp);
			}
			$ddId 		= $elementid . "_dd";
			$ddFolderId = $elementid . "_folder";
			$imageFiles = mosReadDirectory( $mosConfig_absolute_path . '/images/stories/'.  $rootDir );
			$defImages = array(  mosHTML::makeOption( '', '- Select Image -' ) );
			foreach ( $imageFiles as $file ) {
				// $$$ hugh - lets sneak mp3's in there
				if ( eregi( "bmp|gif|jpg|png|mp3", $file ) ) {
					$defImages[] = mosHTML::makeOption( $file );
				}
			}
			$rDir = $mosConfig_absolute_path . "/images/stories" .  $rootDir;
			$images = array( );
			$folders = array( );
			
			$oElement->ReadImages( $rDir, "/", $folders, $images, array() );
			$imageOpts = array();
			$folderOpts = array( );
			$folderOpts[] = mosHTML::makeOption( "", "- Select Folder -" );
			$firstFolderFound = false;
			if ( is_array( $folders ) ) {
				foreach ( $folders as $oDir ) {
					$dir = $oDir->value;
					$newFolderopt = str_replace( $rDir, '', $dir );
					$folderOpts[] = mosHTML::makeOption( $newFolderopt );
					
					if( array_key_exists( $dir, $images ) ){
						$aImgs = $images[$dir];
						foreach( $aImgs as $oImg ){
							if( $newFolderopt == $folderPathToShow ){
								$imageOpts[] = mosHTML::makeOption($oImg->text);
							}
						}
						$firstFolderFound = true;	
					}
				}
			}
			//if no folder selected show the root dir images
			if(empty($imageOpts)){
				$imageOpts = $defImages;
			}
			// $$$ hugh - not sure why $imgPathToShowInDd is including the actual path,
			// $$$ because it doesn't use the path in the displayed image name
			// $$$ so lets use the $imgToShowInDd instead (grabbed it in folder path
			// $$$ processing above
			$imgPathToShowInDd = ltrim($imgPathToShowInDd, "/");
		

			if( $_VERSION->PRODUCT == 'Joomla!' && $_VERSION->RELEASE >= 1.5){
				$str .= mosHTML::selectList( $folderOpts, 'ul_directory', 'id="' . $elementid . '_folder" class="inputbox" size="1" ', 'value', 'text', $folderPathToShow, $ddFolderId );
				$str .= "<br />";		
				$str .= mosHTML::selectList( $imageOpts, $elementHTMLName, ' class="inputbox" size="1" ', 'value', 'text', $imgToShowInDd, $ddId );
			}else{
				///$$$rob 1.0.5 dont show folder opts dd if no folders available
				if (count( $folderOpts ) == 1 && $folderOpts[0]->value == '') {
					$str .= mosHTML::selectList( $folderOpts, 'ul_directory', ' id="' . $ddFolderId . '" class="inputbox" size="1" ', 'value', 'text', $folderPathToShow );
				} else {
					$str .= mosHTML::selectList( $folderOpts, 'ul_directory', ' id="' . $ddFolderId . '" class="inputbox" style="dislay:none" size="1" ', 'value', 'text', $folderPathToShow );
				}
				$str .=  "<br />";		
				$str .= mosHTML::selectList( $imageOpts, $elementHTMLName, 'id="' . $ddId . '" class="inputbox" size="1" ', 'value', 'text', $imgToShowInDd );
			}
			$str .= "<input type='hidden' id='$elementid' name='$elementHTMLName' value='" . $oElement->image_name . "' />"; 
		}
		$str = '<table><tr><td>' . $str . '</td></tr></table>'; // hugh - maintains alignment in non-table templates
		return $str;
	}
		
	/**
	 * draw the user name in a hidden field
	 * @param object element
	 */

	function drawUsername( $oElement ) {
		global $my;
		$elementHTMLId   = $oElement->_elementHTMLId;
		$js				 = $oElement->_js;
		$elementHTMLName = $oElement->_htmlName;
		$params 		 = $oElement->loadParams();
		$type 			 = $params->get('my_data', 'username');
		$str 			 	= $my->$type;
		if (mosGetParam( $_GET, 'rowid' ) != '') {
			//editing an existing record
			$updateOnEdit = $params->get( 'update_onedit', 1 );
			if (!$updateOnEdit) {
				// use the previously recorded data
				$str = $oElement->default;
			}
		}
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName);
		if ($oElement->_editable) {
			$str = "<input type=\"hidden\" $js name=\"$elementHTMLName\" value=\"$str\" id=\"$elementHTMLId\" />\n";
		}			
		return $str;
	}
		
	/**
	 * draw date control
	 * @param object element
	 * @param array data
	 */
	 
	function drawDate( $oElement, $data ) {
		global $database;
		$value 			 			= $oElement->default;
		$elementHTMLId 	 	= $oElement->_elementHTMLId;
		$elementHTMLName 	= $oElement->_htmlName;
		$js				 				= $oElement->_js;
		
		// $$$ hugh - added this, wasn't hiding hidden dates!
		if ($oElement->hidden == '1') {
			return fabrik_html_content::drawField( $oElement, $data, true );
		}
		
		$attribs = $oElement->loadParams();
		$table_format = $attribs->get('date_table_format', 'Y-m-d');
		$form_format = $attribs->get('date_form_format', $table_format);		
		$aNullDates = array('', '0000-00-000000-00-00','0000-00-00 00:00:00','0000-00-00', $database->getNullDate() );
		if (in_array( trim( $value ), $aNullDates )) {
			$value = '';
		} else {
			$value = date( $form_format, strtotime($value));
		}

		if (!$oElement->_editable) {
				return $value;
		}

		$elementHTMLName = str_replace( '.', '___', $elementHTMLName);
		
		$errorCSS  = '';
		if (isset($oElement->_elementError) &&  $oElement->_elementError != '' ) {
			$errorCSS = " elementErrorHighlight";
		}
		$type = "text";
		if ($oElement->hidden == '1') {
			$type = "hidden";
		}
		
		$str = '<input class="inputbox ' . $errorCSS . '" ' . $js . ' type="' . $type . '" name="'.$elementHTMLName.'" size="' . $oElement->element_width . '" maxlength="19" value="'.$value.'" id="'.$elementHTMLId.'"  />';
		if ($type == "text") {
			$js_format = php2js_format($form_format);
			// $$$ rob add in options
			$showTime = $attribs->get('date_showtime', 0) ? 1 : 0;
			$opts = "{'showsTime':{$showTime}}";
			// $$$ hugh - overwriting J!'s default showCalendar in form.js so we can set date format
			$str .= "\n".'<input type="reset" class="button" value="..." onclick="return fabrikShowCalendar(\''.$elementHTMLId.'\', \'' . $js_format. '\', '.$opts.');" />';
		}
		/*
		$str = "<script type=\"text/javascript\">
			if (calendar != null) {
				calendar.setDateFormat('dd-mm-y');
			}
		</script>";
		*/
		return $str;
	}

	/**
	 * draw a button
	 * @param object element
	 */

	function drawButton( $oElement ) {
		$editable 		 = $oElement->_editable;
		$elementHTMLName = $oElement->_htmlName;
		$elementHTMLId   = $oElement->_elementHTMLId;
		$js				 = $oElement->_js;
		if(!$editable){ return; }
		$elementHTMLName = str_replace( '.', '___', $elementHTMLName);
		$str = "<input type='button'  class='button' id='$elementHTMLId' $js name='$elementHTMLName' value='$oElement->element_label' />";
		return $str;
	}
		
	/**
	* Generates an HTML radio list
	* @param array An array of objects
	* @param string The value of the HTML name attribute
	* @param string Additional HTML attributes for the <select> tag
	* @param mixed The key that is selected
	* @param string The name of the object variable for the option value
	* @param string The name of the object variable for the option text
	* @returns string HTML for the select list
	*/
	function radioList( &$arr, $tag_name, $tag_attribs, $selected=null, $key='value', $text='text' ) {
		reset( $arr );
		$html = "";
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = $arr[$i]->$key;
			$t = $arr[$i]->$text;
			$id = ( isset($arr[$i]->id) ? @$arr[$i]->id : null);

			$extra = '';
			$extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					$k2 = $obj->$key;
					if ($k == $k2) {
						$extra .= " selected=\"selected\"";
						break;
					}
				}
			} else {
				$extra .= ($k == $selected ? " checked=\"checked\"" : '');
			}
			$html .= "\n\t<div class=\"fabrikRadioDiv\" id=\"$tag_name" . "_div_" . "$k\"><input type=\"radio\" name=\"$tag_name\" id=\"$tag_name$k\" value=\"".$k."\"$extra $tag_attribs />";
			$html .= "\n\t<label for=\"$tag_name$k\">$t</label></div>";
		}
		$html .= "\n";
		return $html;
	}	
	
	/**
	 * write a page stating that the form or table has not be published yet
	 * @param string 'table' or 'form'
	 */	

	function notPublished( $data ){
		global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang;
		$p =  $mosConfig_absolute_path . '/administrator/components/com_fabrik/language/'.$mosConfig_lang.'.php';
		if (file_exists( $p )) {
			require_once( $p );
		} else {
			$p = $mosConfig_absolute_path . "/administrator/components/com_fabrik/language/english.php";
			if (file_exists( $p )) {
				require_once( $p );
			}
		}
		if ($data == 'table') {
			echo _TABLE_NOT_PUBLISHED ;
		} else {
			echo _FORM_NOT_PUBLISHED;
		}
	}
}

function writeFrontEndfabrikHead($fromModule = false){
	global $mosConfig_lang, $mosConfig_live_site, $_VERSION, $mosConfig_absolute_path, $mainframe, $fabrikConfig;
	if (!defined( '_JOS_FABRIK_FRONT_END_WRITTEN' )) {
		define( '_JOS_FABRIK_FRONT_END_WRITTEN', 1 );
		if(($_VERSION->PRODUCT == 'Mambo' and $_VERSION->RELEASE <= 4.5 and $_VERSION->DEV_LEVEL < 2) || $fromModule)  {
			echo '<script language="Javascript" src="' . $mosConfig_live_site . '/includes/js/overlib_mini.js"></script>';
			echo '<div id="overDiv" style="position:absolute; visibility:hidden; z-index:10000;"></div>';
			echo '<link rel="stylesheet" type="text/css" media="all" href="' . $mosConfig_live_site . '/includes/js/calendar/calendar-mos.css" title="green" />
				<script type="text/javascript" src="' . $mosConfig_live_site . '/includes/js/calendar/calendar_mini.js"></script>
				<script type="text/javascript" src="' . $mosConfig_live_site . '/includes/js/calendar/lang/calendar-en.js"></script>';
			echo '<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/mootools111.js"></script>
				<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/mootools-ext.js"></script>';			
			if ($fabrikConfig->fbConf_use_highslide) {
				echo '<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/highslide/highslide.js"></script>';
				echo '<link rel="stylesheet" type="text/css" href="' . $mosConfig_live_site . '/components/com_fabrik/libs/highslide/css/highslide.css" media="screen" />';
				echo '<script type="text/javascript">hs.graphicsDir = "' . $mosConfig_live_site . '/components/com_fabrik/libs/highslide/graphics/";</script>';
			}
			else {
				echo '<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/slimbox.js"></script>';
				echo '<link rel="stylesheet" type="text/css" href="' . $mosConfig_live_site . '/components/com_fabrik/css/slimbox.css" media="screen" />';
			}
		} else {
			//unfortunately loadCalendar() writes out the css link and js code rather than adding it to the head
			// $$$ hugh - trying new calendar
			//mosCommonHTML::loadCalendar();
			addHeadTag('<link rel="stylesheet" type="text/css" media="all" href="' . $mosConfig_live_site . '/components/com_fabrik/libs/jscalendar/calendar-system.css" title="green" />');
			addHeadTag('<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/jscalendar/calendar.js"></script>');
			addHeadTag('<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/jscalendar/lang/calendar-en.js"></script>');
			mosCommonHTML::loadOverlib(); 
			if($_VERSION->PRODUCT == 'Joomla!' && $_VERSION->RELEASE < 1.5 || ( $_VERSION->PRODUCT == 'Mambo' && $_VERSION->RELEASE >= 4.5 && $_VERSION->DEV_LEVEL >= 2)){
				addHeadTag('<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/mootools111.js"></script>');		
			}
			addHeadTag('<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/mootools-ext.js"></script>');
			// $$$ hugh - slimbox stuff
			if ($fabrikConfig->fbConf_use_highslide) {
				addHeadTag('<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/highslide/highslide.js"></script>');
				addHeadTag('<link rel="stylesheet" type="text/css" href="' . $mosConfig_live_site . '/components/com_fabrik/libs/highslide/css/highslide.css" media="screen" />');
				addHeadTag('<script type="text/javascript">hs.graphicsDir = "' . $mosConfig_live_site . '/components/com_fabrik/libs/highslide/graphics/";</script>');
			}
			else {
				addHeadTag('<script type="text/javascript" src="' . $mosConfig_live_site . '/components/com_fabrik/libs/slimbox.js"></script>');
				addHeadTag('<link rel="stylesheet" type="text/css" href="' . $mosConfig_live_site . '/components/com_fabrik/css/slimbox.css" media="screen" />');
			}
			// $$$ end hugh
		}
		fabrikLanguageFiles();
	}
}


/**
 * split as these may need to be included by the module?
 */
function fabrikLanguageFiles(){
	global $mosConfig_lang, $mosConfig_absolute_path, $mosConfig_live_site;
	if(file_exists( $mosConfig_absolute_path .  '/administrator/components/com_fabrik/language/'.$mosConfig_lang.'.php')){
		include_once ( $mosConfig_absolute_path . '/administrator/components/com_fabrik/language/'.$mosConfig_lang.'.php'); 
	} else {
		if(file_exists( $mosConfig_absolute_path . '/administrator/components/com_fabrik/language/english.php')){
			include_once ( $mosConfig_absolute_path . '/administrator/components/com_fabrik/language/english.php'); 
		}
	}	
}
?>