<?php

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
 
 class fabrikConnection extends fabrikDBTable {
 	
 	/** @var int primary key */
 	var $id = null;
 	
 	/** @var string the ip address or url of the databases host */
 	var $host = null;
 	
 	/** @var string the user name to connect to the database with */
 	var $user = null;
 	
 	/** @var string the users password */
 	var $password = null;
 	
 	/** @var string the name of the database to connect to */
 	var $database = null;
 	
 	/** @var string a description of the connection */
 	var $description = null;
 	
 	/** @var bol published state of element */
 	var $state = 0;
 	
 	/** @var int user id who has checked out connection */
 	var $checked_out  	= null;
 	
 	/** @var date time that connection was checked out */
 	var $checked_out_time  	 = null;
 	
 	/** @var bol is this the default connection - used for advanced element joins */
 	var $default_cnn = null;
 	
 	/** none table vars */
 	/** @var array a list of all the database tables */
 	var $_connectionTables = null;
 	
 	/**
	* @param database A database connector object
	*/
	function fabrikConnection( &$db ) {		
		$this->mosDBTable( '#__fabrik_connections', 'id', $db );
	}
	
	/**
	 * creates a html dropdown box for the current connection
	 * @param string javascript to add to select box
	 * @param string name of dropdown box
	 * @param string the selected element in the list
	 */
	 
	 function getTableDdForThisConnection( $javascript = '', $name = 'table_join', $selected = '' ){
	 	$tableOptions = array( );
		if ( $this->host and $this->state == '1' ) {
			if ( @ mysql_connect( $this->host, $this->user, $this->password ) ) {
				$fabrikDb = new database( $this->host, $this->user, $this->password, $this->database, "", true, true );
				$tables = $fabrikDb->getTableList( );
				foreach( $tables as $table ){
					$tableOptions[] = mosHTML::makeOption( $table, $table );
				}
			} else {
				$tableOptions[] = mosHTML::makeOption( 'couldnt connect' );	
			}
		}else{
			$tableOptions[] = mosHTML::makeOption( 'host not set' );
		}
		return mosHTML::selectList( $tableOptions, $name, 'class="inputbox" size="1" id="' . $name  . '" '.$javascript, 'value', 'text', $selected );
	}
	 
	/**
	 * gets object of connections
	 * @param javascript to run on change
	 */
	 
	 function getConnections(  ){
 		global $database;
		$database->setQuery("SELECT *, id AS value, description AS text FROM #__fabrik_connections WHERE state = '1'");
		$realCnns = $database->loadObjectList();
		echo $database->getErrorMsg();
		return $realCnns;
	 }

	/**
	 * gets dropdown list of published connections
	 * @param object connections stored in database
	 * @param string javascript to run on change
	 * @param string name of connection drop down
	 * @param int default value
	 */
	 	 
	 function getConnectionsDd( $realCnns, $javascript, $name = 'connection_id', $selected ){
		$cnns[] = mosHTML :: makeOption( '-1', _CHOOSE_NO_CONNECTION );	 
		$cnns = array_merge( $cnns, $realCnns );	
		return mosHTML :: selectList( $cnns, $name, 'class="inputbox" size="1" id="' . $name  . '" '.$javascript, 'value', 'text', $selected );
	 }
		  	
	/**
	 * queries all published connections and returns an multidimensional array
	 * of tables for each connection
	 * @param object all available connections
	 */
	 
	function getConnectionTables( $realCnns ){
		global $database;
		$connectionTables = array (); 
		$connectionTables[-1] = array ();
		$connectionTables[-1][] = mosHTML :: makeOption( '-1', _CHOOSE_TABLE );
		foreach ($realCnns as $cn) {
			$connectionTables[$cn->value] = array ();
			if ($cn->host and $cn->state == '1') {
				if ( @mysql_connect( $cn->host, $cn->user, $cn->password ) ) {
					$fabrikDb = new database( $cn->host, $cn->user, $cn->password, $cn->database, "", true, true );
					$tables = $fabrikDb->getTableList();
					foreach ( $tables as $table ) {
						$connectionTables[$cn->value][] = mosHTML :: makeOption( $table, $table );
					}
				}else{
					$connectionTables[$cn->value][] = mosHTML :: makeOption( '', "unable to connection to $cn->description" );
				}
			}
		}
		return $connectionTables;
	}
	
	/**
	 * tests if you can connect to the connection
	 * @return bol true if connection made otherwise false
	 */
	 
	function testConnection(){
		if ( @mysql_connect( $this->host, $this->user, $this->password, true ) ) {
			if (!mysql_select_db( $this->database ) ) {
				return false;
			}	
			return true;			
		}else{
			return false;
		}
	}
	
	/**
	 * load the connection associated with the table
	 * @return object database object using connection details false if connection error
	 */
	
	function loadTableConnectionDB(){
		global $mosConfig_dbprefix;
		if ( $this->testConnection() ) {
			$fabrikDb = new fabrikDatabase( $this->host, $this->user, $this->password, $this->database, $mosConfig_dbprefix, true, true );
			return $fabrikDb;
		}else{
			return false;
		}	
	}
	
	/**
	 * load the default connection
	 * @return connection
	 */
	 
	 function loadDefaultConnection(){
		global $database;
		$k = $this->_tbl_key;
		$class_vars = get_class_vars( get_class( $this ) );
		foreach ( $class_vars as $name => $value ) {
			if (($name != $k) and ($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
				$this->$name = $value;
			}
		}
		$sql = "SELECT * FROM $this->_tbl WHERE default_cnn = '1'";
		$this->_db->setQuery( $sql );
		return $this->_db->loadObject( $this );	 	
	 }
 }

 ?>