<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrik_export {
	
	var $label				= '';
	var $tableIds 			= array();
	var $format 			= 'xml';
	var $includeData 		= false;
	var $fabrikData 		= false;
	var $incTableStructure  = false;
	var $_aTables 			= array();
	var $_aFiles			= array();
	var $_tmpFolder			= null;
	/** @var param bol include template files in package */
	var $incTemplates = true;
	
	function fabrik_export( $label, $cid, $format, $includeData, $fabrikData, $tablestructure )
	{
		$this->setConf( $label, $cid, $format, $includeData, $fabrikData, $tablestructure );  	
	}
    
	function setConf( $label, $cid, $format, $includeData, $fabrikData, $tablestructure )
	{
    global $mosConfig_absolute_path;
    $this->tableIds			  = $cid;
    $this->format 			  = $format;
		$this->includeData 		  = $includeData;
		$this->fabrikData 		  = $fabrikData;
		$this->label			  = $label;
		$this->incTableStructure  = $tablestructure;
		$this->_tmpFolder		  = mosPathName( $mosConfig_absolute_path. '/media' );
		// $$$ hugh - breaks most installs where apache user doesn't own ./media
		// and its kind of out of our worry orbit - up to user to control dir perms
		//chmod($this->_tmpFolder, 0777);
    }
    
	 /**
	 * export table data 
	 * @param string export format xml/csv
	 * @param bol export the table actual records
	 * @param bol export the msoform records associated with the table (group.elements, forms etc)
	 * @param bol save the exported file as a zip
	 */
	 
	function export( )
	{
		global $database;
		switch( $this->format ){
			case 'csv':
				$this->_csvExport( );
				break;
			case 'xml':
			default:
				$xml = $this->_buildXML( );
				$this->_xmlExport( $xml );
				break;
		}	
	}
	
	/**
	 * collates the template files
	 * @return string xml string
	 */
	 
	function getTemplateFiles( )
	{
	 	global $mosConfig_absolute_path;
	 	if (!$this->incTemplates) {
	 		return '';
	 	}
	 	$templatePath = $mosConfig_absolute_path . '/components/com_fabrik/views/table/tmpl/' ;
	 	$aFolders = array();
	 	foreach ($this->_aTables as $oTable) {
	 		if (!in_array( 'views/table/tmpl/' . $oTable->table_template . "/", $aFolders )) {
	 			$aFolders[] = 'views/table/tmpl/' . $oTable->table_template . "/";
	 		}
	 		
	 		$templatePath = $mosConfig_absolute_path . '/components/com_fabrik/views/form/tmpl/' ;
	 		if ($oTable->_oForm->form_template != '') {
	 			if (is_dir( $templatePath . $oTable->_oForm->form_template )) {
	 				if (!in_array( 'views/form/tmpl/' . $oTable->_oForm->form_template . "/", $aFolders )) {
	 					$aFolders[] = 'views/form/tmpl/' . $oTable->_oForm->form_template . "/";
	 				}
	 			}
	 		}
	 		if ($oTable->_oForm->view_only_template != '') {
	 			if (is_dir($templatePath . $oTable->_oForm->view_only_template )) {
	 				if (!in_array( 'views/form/tmpl/' . $oTable->_oForm->view_only_template . "/", $aFolders )) {
	 					$aFolders[] = 'views/form/tmpl/' . $oTable->_oForm->view_only_template . "/";
	 				}
	 			}
	 		}
	 	}
	 	$aFiles 	= array();
	 	$aAllFiles 	= array();
	 	$filter = ".";
		$filter = '\.css$|\.php$|\.js$|\.jpg$|\.jpeg$|\.gif$|\.png$';
	 	foreach ($aFolders as $folder) {
			$folder 	=  $mosConfig_absolute_path . '/components/com_fabrik/' . $folder;
	 		$aAllFiles 	= array_merge($aAllFiles, mosReadDirectory($folder, '.', true, true ));
	 	}
	 	for ($i=0;$i<count($aAllFiles);$i++) {
	 		if (!strstr($aAllFiles[$i], '.svn')) {
	 			$fileP =  str_replace( mosPathName( $mosConfig_absolute_path ) , '', $aAllFiles[$i] );
	 			if (!in_array( $fileP, $aFiles )) {
	 				$aFiles[] = $fileP;
	 			}
	 		}
	 	}
	 	
	 	$xml = "<files>\n";
	 	foreach ($aFiles as $file) {
			$file = str_replace( 'components/com_fabrik/', '', $file );
			$file = str_replace( 'components\com_fabrik', '', $file );
	 		$xml .= "\t<file>$file</file>\n";
	 	}
	 	$this->_aFiles = $aFiles;
	 	$xml .= "</files>\n";	
	 	return $xml;
	 }
	 
	/**
	 * builds the xml installer file for a given table
	 * @return string xml file
	 */
	 
	function _buildXML( )
	{
		global $mosConfig_absolute_path, $mosConfig_live_site, $database;
		//$this->clearExportBuffer();
		$strXML = "<?xml version=\"1.0\" ?>\n";
		$strXML .= "<mosinstall type=\"fabrik\" version=\"1.0\">\n";
		$aTableObjs = array();
		
		if ($this->fabrikData) {
			
			$strXML .= "<tables>\n";
			if (is_array( $this->tableIds	)) {
				foreach ($this->tableIds as $tableId) {
					$oTable = new fabrikTable( $database );
					$oTable->load( $tableId );
					$oTable->getForm();
					$this->_aTables[] = $oTable;
					$vars = get_object_vars( $oTable );
					$strXML .= "\t<table>\n";
					foreach ($vars as $key=>$val) {
						if (substr( $key, 0, 1) != '_') {
							$strXML .= "\t\t<$key><![CDATA[$val]]></$key>\n";
						}	
					}
					$strXML .= "\t</table>\n";
				}
			}
			
			$strXML .= "</tables>\n\n";
			
			$strXML .= "<forms>\n";
			foreach ($this->_aTables as $oTable) {
				$vars = get_object_vars( $oTable->_oForm );
				$strXML .= "\t<form>\n";
				foreach ($vars as $key=>$val) {
					if (substr($key, 0, 1) != '_') {
						$strXML .= "\t\t<$key><![CDATA[$val]]></$key>\n";
					}
				}
				$strXML .= "\t</form>\n";
			}
			$strXML .= "</forms>\n\n";
			
			$strElementXML 		= "<elements>\n";
			$strXML 			.= "<groups>\n";
			$strValidationXML 	= "<validations>\n";
			foreach ($this->_aTables as $oTable) {
				$groups = $oTable->_oForm->getFormGroupsHiarachy( false, false );
				
				$i = 0;
				foreach ($groups as $oGroup) {
					$vars = get_object_vars( $oGroup );
					$strXML .= "\t<group form_id=\"" . $oTable->_oForm->id  ."\" ordering=\"" . $i  ."\">\n";
					foreach ($vars as $key=>$val) {
						//dont insert join_id as this isnt in the group table
						if ($key != "join_id" && substr( $key, 0, 1 ) != '_') {
							$strXML .= "\t\t<$key><![CDATA[$val]]></$key>\n";
						}
					}
					$strXML .= "\t</group>\n";
					
					foreach ($oGroup->_aElements as $oElement) {
						$vars = get_object_vars( $oElement );
						$strElementXML .= "\t<element>\n";
						foreach ( $vars as $key=>$val) {
							if (substr( $key, 0, 1 ) != '_' ) {
								$strElementXML .= "\t\t<$key><![CDATA[$val]]></$key>\n";
							}
						}
						$strElementXML .= "\t</element>\n\n";
						
						foreach ($oElement->_aValidations as $oValidation) {
							$vars = get_object_vars( $oValidation );
							$strValidationXML .= "\t<validation>\n";
							foreach ($vars as $key=>$val) {
								if (substr( $key, 0, 1) != '_') {
									$strValidationXML .= "\t\t<$key><![CDATA[$val]]></$key>\n";
								}	
							}
							$strValidationXML .= "\t</validation>\n\n";
						}
					}
					$i++;
				}
			}
			$strXML 			.= "</groups>\n";
			$strElementXML 		.= "</elements>\n\n";
			$strValidationXML 	.= "</validations>\n\n";
			$strXML .= $strElementXML . $strValidationXML;
				
		}
		$this->writeExportBuffer( $strXML );
		if ($this->incTableStructure || $this->includeData) {
			$this->_createQueriesXML( );
		}
		$strXML = $this->getTemplateFiles( );
		$strXML .= "</mosinstall>";
		$this->writeExportBuffer( $strXML );	
	}
	
	/**
	 * 
	 */
	 
	 function _createQueriesXML( )
	 {
	 	global $database;
	 	$aUsedTables = array();
	 	$this->writeExportBuffer(  "<queries>\n");
		for ($i=0;$i<count( $this->_aTables );$i++) {
	 		$tmpTable = $this->_aTables[$i];
	 		
	 		if (!in_array( $tmpTable->db_table_name, $aUsedTables )) {
		 		$aUsedTables[] = $tmpTable->db_table_name;
		 		if ($this->incTableStructure) {
			 		$this->writeExportBuffer(  "\t<query>" . $tmpTable->getDropTableSQL() . "</query>\n" ); 
			 		$this->writeExportBuffer("\t<query>" . $tmpTable->getCreateTableSQL() . "</query>\n" );
		 		}
		 		if ($this->includeData) {
					$tmpTable->getInsertRowsSQL( $this );
		 		}
	 		}
	 		//$$$ rob - get join table sql as well!
			$aJoinObjs 		= $tmpTable->loadJoins( );
			foreach ($aJoinObjs as $oJoin) {
				$table = $oJoin->table_join;
				if (!in_array( $table, $aUsedTables )) {
					$aUsedTables[] = $table;
					$oJoinTable = new fabrikTable( $database );
					//populate the table with the minimum info to all for sql statement creation
					$oJoinTable->db_table_name = $table;
					$aKeyInfo = $oJoinTable->getPrimaryKeyAndExtra();
					$oJoinTable->db_primary_key = $aKeyInfo['colname'];
					if ($this->incTableStructure) {
						$this->writeExportBuffer(  "\t<query>" . $oJoinTable->getDropTableSQL() . "</query>\n" ); 
			 			$this->writeExportBuffer("\t<query>" . $oJoinTable->getCreateTableSQL() . "</query>\n" );
					}
					if ($this->includeData) {
						$oJoinTable->getInsertRowsSQL( $this );
			 		}
				}
			}
	 		
	 	}
	 	//include any database join element tables in the xml
	 	foreach ($this->_aTables as $tmpTable) {
	 		$aGroups = $tmpTable->getFormGroupElementData( null, false, false );
	 		
	 		foreach ($aGroups as $oGroup) {
		 		foreach ($oGroup->_aElements as $oElement) {
		 			if ($oElement->elementtype_id == "12") {
		 				$table = $oElement->join_db_name;
		 				if (!in_array( $table, $aUsedTables )) {
		 					$aUsedTables[] = $table;
		 					
			 				$oJoinTable = new fabrikTable( $database );
							//populate the table with the minimum info to all for sql statement creation
							$oJoinTable->db_table_name = $table;
							$aKeyInfo = $oJoinTable->getPrimaryKeyAndExtra();
							$oJoinTable->db_primary_key = $aKeyInfo['colname'];
							if ($this->incTableStructure) {
								$this->writeExportBuffer(  "\t<query>" . $oJoinTable->getDropTableSQL() . "</query>\n" ); 
					 			$this->writeExportBuffer("\t<query>" . $oJoinTable->getCreateTableSQL() . "</query>\n" );
							}
							if ($this->includeData) {
								$oJoinTable->getInsertRowsSQL( $this );
					 		}
		 				}
		 			}
		 		}
	 		}
	 	}
	 	$this->writeExportBuffer("</queries>\n");
	 }
	 
	function clearExportBuffer()
	{
	 	$filename =  $this->_tmpFolder . 'fabrik_package-' . $this->label . '.xml';
		@unlink($filename);
	}
	 
	 function writeExportBuffer( $str )
	 {
	 	global $mosConfig_absolute_path;
	 	$filename =  $this->_tmpFolder . 'fabrik_package-' . $this->label . '.xml';
		// Let's make sure the file exists and is writable first.
		if (file_exists( $filename )){
			if (!is_writable( $filename )) {
				echo "The file $filename is not writable";
				return;
			}
		}
		if (!$handle = fopen($filename, 'a')) {
			echo "Cannot open file ($filename)";
			exit;
		}
	
		// Write $somecontent to our opened file.
		if (fwrite($handle, $str) === FALSE) {
			echo "Cannot write to file ($filename)";
			exit;
		}
		fclose($handle);
	}
	 
	/**
	 * 
	 */
	
	function _xmlExport( $xml )
	{
		global $mosConfig_absolute_path, $mosConfig_live_site;
		if (!is_writable($this->_tmpFolder )) {
			die("$this->_tmpFolder is not writable, export is unable to continue");
		}
		$archieveName =  'fabrik_package-' . $this->label;
		require_once( $mosConfig_absolute_path . '/includes/Archive/Tar.php' );
		
		$archievePath = $this->_tmpFolder . $archieveName . '.tgz';
		if (file_exists( $archievePath )) {
			@unlink($archievePath);
		}
		$zip = new Archive_Tar( $archievePath );
		$fileName =  $archieveName . '.xml';
		$xmlFilePath = $this->_tmpFolder . $fileName;
		if (!file_exists( $xmlFilePath )) {
			die('cant find xml setup file -' . $xmlFilePath );
		}
		$ok = $zip->addModify( array($xmlFilePath), '', $this->_tmpFolder );
		if (!$ok) {
			die( 'didnt add xml setup file - ' . $xmlFilePath );
		}
		
		for ($i = 0;$i<count( $this->_aFiles );$i++) {
			$this->_aFiles[$i] = $mosConfig_absolute_path. '/' . $this->_aFiles[$i];
		}
		$zip->addModify( $this->_aFiles, '', $mosConfig_absolute_path. '/components/com_fabrik' );
		$this->_output_file( $archievePath, $archieveName . '.tgz' );
		if (file_exists( $archievePath )) {
			@unlink( $archievePath );
		}
		if (file_exists( $xmlFilePath )) {
			@unlink( $xmlFilePath );
		}
	}
	
	function _csvExport( )
	{
		global $database;
		initGzip();
		$oTable = new fabrikTable( $database );
		$oTable->setAdmin( false );
		$oConn = new fabrikConnection( $database );
		$id = $this->tableIds[0];
		$oTable->load( $id );
		//$oTable->_aData = array();
		$oTable->_aData = $_REQUEST; // $$$ hugh - testing filters for csv
		$oTable->getConnection();
		header('Content-Type: text/plain');
		header('Content-Disposition: attachment; filename="' . $oTable->label . '-export.csv"');
		$aFilter 		= array();
		$oTable->getForm( );
		$ar = $oTable->getFormGroupElementData();
		
		$oTable->getFilterArray( ); // hugh $$$ testing
		
		$oTable->_outPutFormat = 'csv';
		$params 		= $oTable->loadParams();
		$longNames		= $params->get('csvfullname', 0);
		$limitLength 	= $oTable->getTotalRecords( );
		$pageNav 		= new fabrikPageNav( $limitLength, 0, $limitLength );
		$formdata 		= $oTable->getTableData( $pageNav );
		if (is_array( $formdata )) {
			$firstrow = mosObjectToArray( $formdata[0][0] );
			if (is_array( $firstrow )) {
				$headings = array_keys( $firstrow );
				$str = $oTable->db_table_name;
				for ($h = count( $headings )-1; $h>=0;$h--) {
					if (substr( $headings[$h], 0, 8 ) == "fabrik__") {
						unset($headings[$h]);
					}
				}
				echo implode( ",", $headings );
			}
			foreach ($formdata as $group) {
				foreach ($group as $row) {
					echo "\n";
					//remove data such as fabrik__cursor and fabrik__total
					foreach ($row as $key => $val) {
						if (substr( $key, 0, 8 ) == "fabrik__") {
							unset($row->$key);
						}
					}
					echo implode( ",", array_map(array($this, "_quote"), array_values(mosObjectToArray( $row ))) );
				}
			}
		}
		doGzip();		
	}
	
	function _quote($n)
	{
		//test to remove new line characters from csv data
		$n = str_replace("\n", "", $n);
		return '"'.str_replace('"', '""', $n).'"'; 
	}
	
	function _removeInternal( $var, $val)
	{
		echo $var . " = " . $val . "<br />";
	}
	
	function _output_file( $file, $name )
	{
		/*do something on download abort/finish
		register_shutdown_function( 'function_name'  );*/
		if (!file_exists( $file ))
			die('file not exist!');
		$size = filesize($file);
		$name = rawurldecode($name);
	
		if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT']))
			$UserBrowser = "Opera";
		elseif (ereg('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT']))
			$UserBrowser = "IE";
		else
			$UserBrowser = '';
	
		/* important for download im most browser */
		$mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ?
		 'application/octetstream' : 'application/octet-stream';
		@ob_end_clean(); 
		/* decrease cpu usage extreme */
		header('Content-Type: ' . $mime_type);
		header('Content-Disposition: attachment; filename="'.$name.'"');
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header('Accept-Ranges: bytes');
		header("Cache-control: private");
		header('Pragma: private');
		
		/* multipart-download and resume-download */
		if (isset( $_SERVER['HTTP_RANGE'] )) {
			list($a, $range) = explode("=",$_SERVER['HTTP_RANGE']);
			str_replace($range, "-", $range);
			$size2 = $size-1;
			$new_length = $size-$range;
			header("HTTP/1.1 206 Partial Content");
			header("Content-Length: $new_length");
			header("Content-Range: bytes $range$size2/$size");
		} else {
			$size2=$size-1;
			header("Content-Length: ".$size);
		}
		$chunksize = 1*(1024*1024);
		$this->bytes_send = 0;
		if ($file = fopen($file, 'r')) {
			if(isset($_SERVER['HTTP_RANGE']))
				fseek($file, $range);
			while(!feof($file) and (connection_status()==0)){
				$buffer = fread($file, $chunksize);
				print($buffer);
				flush();
				$this->bytes_send += strlen($buffer);
				/*sleep(1); decrease download speed */
			}
		fclose($file);
		
		}else
			die('error can not open file');
		if(isset($new_length))
			$size = $new_length;
	}
}

?>