<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/*
 * shared functions between the admin and front end
 */

 /**
  * makes the table navigation html to traverse the table data
  * @param int the total number of records in the table
  * @param int number of records to show per page
  * @param int which record number to start at
  */

 
if ( !function_exists('htmlspecialchars_decode') )
{
    function htmlspecialchars_decode($text)
    {
        return strtr($text, array_flip(get_html_translation_table(HTML_SPECIALCHARS)));
    }
}

/**
 * get a list of directories
 * @param string path to read from
 * @param bol return full paths or not
 */

function fabrikListDirs($path, $fullpath = false){
	$arr = array();
	if (!@is_dir( $path )) {
		return $arr;
	}
	$handle = opendir( $path );

	while ($file = readdir($handle)) {
		$dir = mosPathName( $path.'/'.$file, false );
		$isDir = is_dir( $dir );
		if (($file != ".") && ($file != "..") && ($file != ".svn")) {
			if ($isDir) {
				if ($fullpath) {
					$arr[] = trim( mosPathName( $path.'/'.$file, false ) );
				} else {
					$arr[] = trim( $file );
				}
			}
		}
	}
	closedir($handle);
	asort($arr);
	return $arr;
}

 /**
  * extension to the normal pagenav functions
  * @param int total
  * @param int limitstart
  * @param int limit
  */

 class fabrikPageNav {
	/** @var int The record number to start dislpaying from */
	var $limitstart = null;
	/** @var int Number of rows to display per page */
	var $limit 		= null;
	/** @var int Total number of rows */
	var $total 		= null;
 	var $_formName = 'fabrikTable';
	var $_tableid = '0';
	
 	function fabrikPageNav( $total, $limitstart, $limit ) {
		$this->total 		= (int) $total;
		$this->limitstart 	= (int) max( $limitstart, 0 );
		$this->limit 		= (int) max( $limit, 1 );
		if ($this->limit > $this->total) {
			$this->limitstart = 0;
		}
		if (($this->limit-1)*$this->limitstart > $this->total) {
			$this->limitstart -= $this->limitstart % $this->limit;
		}
	}
	
 	function getPagesLinks() {
 		$html 				= '';
 		global $mosConfig_live_site;
 		$displayed_pages 	= 10;
 		$total_pages 		= ceil( $this->total / $this->limit );
 		$this_page 			= ceil( ($this->limitstart+1) / $this->limit );
 		$start_loop 		= (floor(($this_page-1)/$displayed_pages))*$displayed_pages+1;
 		if ($start_loop + $displayed_pages - 1 < $total_pages) {
 			$stop_loop = $start_loop + $displayed_pages - 1;
 		} else {
 			$stop_loop = $total_pages;
 		}
 		if (!defined( '_PN_LT' ) || !defined( '_PN_RT' ) ) {
			DEFINE('_PN_LT','&lt;');
			DEFINE('_PN_RT','&gt;');
		}
		
		$pnSpace = '';
		if (_PN_LT || _PN_RT) $pnSpace = "&nbsp;";
		
 		if ($this_page > 1) {
 			$page = ($this_page - 2) * $this->limit;
 			$html .= "\n<a href=\"#beg\" class=\"pagenav\" title=\"" . _PN_START. "\" id='table_" . $this->_tableid  . "_nav-start'>" . _PN_LT . _PN_LT . $pnSpace . _PN_START . "</a>";
 			$html .= "\n<a href=\"#prev\" class=\"pagenav\" title=\"" . _PN_PREVIOUS . "\" id='table_" . $this->_tableid  . "_nav-previous'>" . _PN_LT . $pnSpace . _PN_PREVIOUS . "</a>";
 		} else {
 			$html .= "\n<span class=\"pagenav\">" . _PN_LT . _PN_LT . $pnSpace . _PN_START."</span>";
 			$html .= "\n<span class=\"pagenav\">" . _PN_LT . $pnSpace . _PN_PREVIOUS . "</span>";
 		}

 		for ($i=$start_loop; $i <= $stop_loop; $i++) {
 			$page = ($i - 1) * $this->limit;
 			if ($i == $this_page) {
 				$html .= "\n<span class=\"pagenav\"> $i </span>";
 			} else {
 				$html .= "\n<a href=\"#$i\" class=\"pagenav\" id='table_" . $this->_tableid  . "_nav-".$i."'><strong>$i</strong></a>";
 			}
 		}

 		if ($this_page < $total_pages) {
 			$page = $this_page * $this->limit;
 			$end_page = ($total_pages-1) * $this->limit;
 			$html .= "\n<a href=\"#next\" class=\"pagenav\" title=\"" ._PN_NEXT . "\" id='table_" . $this->_tableid  . "_nav-next'> " . _PN_NEXT . $pnSpace . _PN_RT . "</a>";
 			$html .= "\n<a href=\"#end\" class=\"pagenav\" title=\"" ._PN_END ."\" id='table_" . $this->_tableid  . "_nav-end'> " . _PN_END . $pnSpace . _PN_RT . _PN_RT ."</a>";
 		} else {
 			$html .= "\n<span class=\"pagenav\">" . _PN_NEXT. $pnSpace . _PN_RT . "</span>";
 			$html .= "\n<span class=\"pagenav\">" . _PN_END. $pnSpace . _PN_RT. _PN_RT . "</span>";
 		}
 		return $html;
 	}

 	function setTableId($tid){
 		$this->_tableid = $tid;
 	}
 	/**
 	 * @return string The html for the limit # input box
 	 */
 	function getLimitBox ( $tableid = 0 ) {
 		$limits = array();
 		for ($i=5; $i <= 30; $i+=5) {
 			$limits[] = mosHTML::makeOption( "$i" );
 		}
 		$limits[] = mosHTML::makeOption( "50" );

 		// build the html select list
 		$html = mosHTML::selectList( $limits, 'limit', 'class="inputbox" size="1" id="table_'. $this->_tableid . '_nav-limit"',
		'value', 'text', $this->limit );
		$html .= "\n<input type=\"hidden\" id=\"table_" . $this->_tableid . "_limitstart\" name=\"limitstart\" value=\"$this->limitstart\" />";
		return $html;
	}
	
 	function getListFooter() {
		$html = '<table class="adminlist"><tr><th colspan="3">';
		$html .= $this->getPagesLinks();
		$html .= '</th></tr><tr>';
		$html .= '<td nowrap="nowrap" width="48%" align="right">' . _DISPLAY . '</td>';
		$html .= '<td>' .$this->getLimitBox() . '</td>';
		$html .= '<td nowrap="nowrap" width="48%" align="left">' . $this->getPagesCounter() . '</td>';
		$html .= '</tr></table>';
  		return $html;
	}
	
 	/**
	* @return string The html for the pages counter, eg, Results 1-10 of x
	*/
	function getPagesCounter() {
		$html = '';
		$from_result = $this->limitstart+1;
		if ($this->limitstart + $this->limit < $this->total) {
			$to_result = $this->limitstart + $this->limit;
		} else {
			$to_result = $this->total;
		}
		if ($this->total > 0) {
			$html .= _PN_RESULTS ." ". $from_result . " - " . $to_result . " " . _PN_OF ." " . $this->total;
		} else {
			$html .= _NO_RECORDS_FOUND;
		}
		return $html;
	}
}
	

 /** returns all elements in $all which are not in $used in O(n log n) time.
  * elements from $all are prefixed with $prefix_all.
  * elements from $used are prefixed with $prefix_used.
  */
  
 function filter_unused( $all, $used, $prefix_all = "", $prefix_used = "" ) {
	 $unused = array();
	 /* prefixes are not needed for sorting */
	 sort( $all );
	 sort( $used );
	 $a = 0;
	 $u = 0;
	 $maxa = sizeof($all)-1;
	 $maxu = sizeof($used)-1;
	 while( true ) {
	    if( $a > $maxa ) {
	        break;
	    }
	    if( $u > $maxu ) {
	        /* rest of $all is unused */
	        for( ; $a <= $maxa; $a++ ) {
	            $unused[] = $all[$a];
	        }
	        break;
	    }
		if( $prefix_all.$all[$a] > $prefix_used.$used[$u] ) {
	        $u++;
	        continue;
		}	
		if( $prefix_all.$all[$a] == $prefix_used.$used[$u] ) {
            $a++;
            $u++;
            continue;
		}
		$unused[] = $all[$a];
		$a++;
	}
	return $unused;
}

// $$$ hugh - added this as last resort for sites where addCustomHeadTag
// isn't working.  Also added $fbConf_use_addCustomHeadTag to config,
// and changed all calls to $mainframe->addCustomHeadTag() to call this
// instead.
function addHeadTag($file)
{
	global $fabrikConfig, $mainframe;
	if ($fabrikConfig->fbConf_use_addCustomHeadTag) {
		$mainframe->addCustomHeadTag($file);
	}
	else {
		echo $file;
	}
}

// $$$ hugh - josSpoofCheck problems.
// Looks like some people are still running versions of J! prior to
// josSpoofCheck() being added (1.0.13, I think).  So I'm seeing if we can
// just clone the code from 1.0.13 if josSpoofCheck() isn't defined.
if ( !function_exists('josSpoofCheck') )
{
	function josSpoofCheck( $header=NULL, $alt=NULL ) {
		$validate 	= mosGetParam( $_POST, josSpoofValue($alt), 0 );
	
		// probably a spoofing attack
		if (!$validate) {
			header( 'HTTP/1.0 403 Forbidden' );
			mosErrorAlert( _NOT_AUTH );
			return;
		}
	
		// First, make sure the form was posted from a browser.
		// For basic web-forms, we don't care about anything
		// other than requests from a browser:
		if (!isset( $_SERVER['HTTP_USER_AGENT'] )) {
			header( 'HTTP/1.0 403 Forbidden' );
			mosErrorAlert( _NOT_AUTH );
			return;
		}
	
		// Make sure the form was indeed POST'ed:
		//  (requires your html form to use: action="post")
		if (!$_SERVER['REQUEST_METHOD'] == 'POST' ) {
			header( 'HTTP/1.0 403 Forbidden' );
			mosErrorAlert( _NOT_AUTH );
			return;
		}
	
		if ($header) {
		// Attempt to defend against header injections:
			$badStrings = array(
				'Content-Type:',
				'MIME-Version:',
				'Content-Transfer-Encoding:',
				'bcc:',
				'cc:'
			);
	
			// Loop through each POST'ed value and test if it contains
			// one of the $badStrings:
			_josSpoofCheck( $_POST, $badStrings );
		}
	}
	
	function _josSpoofCheck( $array, $badStrings ) {
		// Loop through each $array value and test if it contains
		// one of the $badStrings
		foreach( $array as $v ) {
			if (is_array( $v )) {
				_josSpoofCheck( $v, $badStrings );
			} else {
				foreach ( $badStrings as $v2 ) {
					if ( stripos( $v, $v2 ) !== false ) {
						header( 'HTTP/1.0 403 Forbidden' );
						mosErrorAlert( _NOT_AUTH );
						exit(); // mosErrorAlert dies anyway, double check just to make sure
					}
				}
			}
		}
	}
	
	/**
	 * Method to determine a hash for anti-spoofing variable names
	 *
	 * @return	string	Hashed var name
	 * @static
	 */
	function josSpoofValue($alt=NULL) {
		global $mainframe;
	
		if ($alt) {
			if ( $alt == 1 ) {
				$random		= date( 'Ymd' );
			} else {
				$random		= $alt . date( 'Ymd' );
			}
		} else {
			$random		= date( 'dmY' );
		}
		// the prefix ensures that the hash is non-numeric
		// otherwise it will be intercepted by globals.php
		$validate 	= 'j' . mosHash( $mainframe->getCfg( 'db' ) . $random );
	
		return $validate;
	}
}

// $$$ hugh
// need to convert PHP style date format to UNIX style for calendar.js
// http://www.dynarch.com/demos/jscalendar/doc/html/reference.html#node_sec_5.3.5


function php2js_format($format)
{
	$format_xlat = array(
		'd' => 'd',
		'D' => 'a',
		'j' => 'e',
		'l' => 'A',
		'N' => 'u',
		'w' => 'w',
		'W' => 'W',
		'z' => 'j',
		'F' => 'B',
		'm' => 'm',
		'M' => 'b',
		'n' => 'm',
		'Y' => 'Y',
		'y' => 'y',
		'a' => 'P',
		'A' => 'p',
		'g' => 'l',
		'G' => 'k',
		'H' => 'H',
		'h' => 'I',
		'i' => 'M',
		's' => 'S',
		'u' => 's'
	);
	$js_format = '';
	for ($i = 0; $i < strlen($format); ++$i)
	{
		$ch = $format[$i];
		if (array_key_exists( $ch, $format_xlat )) {
			if ($format_xlat[$ch])
			{
				$js_format .= '%' . $format_xlat[$ch];	
			}
			else
			{
				$js_format .= $ch;
			}
		}
		else
		{
			$js_format .= $ch;
		}
	}
	return $js_format;
}

function strToDateTime($date, $format) {
	$weekdays = array (
		'Sun' => '0',
		'Mon' => '1',
		'Tue' => '2',
		'Wed' => '3',
		'Thu' => '4',
		'Fri' => '5',
		'Sat' => '6'
	);
	$months = array (
		'Jan' => '01',
		'Feb' => '02',
		'Mar' => '03',
		'Apr' => '04',
		'May' => '05',
		'Jun' => '06',
		'Jul' => '07',
		'Aug' => '08',
		'Sep' => '09',
		'Oct' => '10',
		'Nov' => '11',
		'Dec' => '12'
	);
	if(!($date = str2Time($date, $format))) return;
	print_r($date);
	$dateTime = array('sec' => 0, 'min' => 0, 'hour' => 0, 'day' => 0, 'mon' => 0, 'year' => 0, 'timestamp' => 0);
	foreach($date as $key => $val) {
		switch($key) {
			case 'd':
			case 'j': $dateTime['day'] = intval($val); break;
			case 'D': $dateTime['day'] = intval($weekdays[$val]); break;

			case 'm':
			case 'n': $dateTime['mon'] = intval($val); break;
			case 'M': $dateTime['mon'] = intval($months[$val]); break;

			case 'Y': $dateTime['year'] = intval($val); break;
			case 'y': $dateTime['year'] = intval($val)+2000; break;

			case 'G':
			case 'g':
			case 'H':
			case 'h': $dateTime['hour'] = intval($val); break;

			case 'i': $dateTime['min'] = intval($val); break;

			case 's': $dateTime['sec'] = intval($val); break;
		}
	}
	$dateTime['timestamp'] = mktime($dateTime['hour'], $dateTime['min'], $dateTime['sec'], $dateTime['mon'], $dateTime['day'], $dateTime['year']);
	return $dateTime;
}

function str2Time($date, $format) {
    $search = array('d', 'D', 'j', // day
                    'm', 'M', 'n', // month
                    'Y', 'y', // year
                    'G', 'g', 'H', 'h', // hour
                    'i', 's');
    $replace = array('(\d{2})', '(\w{3})', '(\d{1,2})', //day
                     '(\d{2})', '(\w{3})', '(\d{1,2})', // month
                     '(\d{4})', '(\d{2})', // year
                     '(\d{1,2})', '(\d{1,2})', '(\d{2})', '(\d{2})', // hour
                     '(\d{2})', '(\d{2})');
   
    $pattern = str_replace($search, $replace, $format);
    if(!preg_match("#$pattern#", $date, $matches)) {
        return false;
    }
    $dp = $matches;
   
    if(!preg_match_all('#(\w)#', $format, $matches)) {
        return false;
    }
    $id = $matches['1'];

    if(count($dp) != count($id)+1) {
    	return false;
    }

    $ret = array();
    for($i=0, $j=count($id); $i<$j; $i++) {
        $ret[$id[$i]] = $dp[$i+1];
    }

    return $ret;
}

?>