<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrikGroup extends fabrikDBTable{

  /** @var int primary key */
  var $id = null;

  /** @var string group name - internal reference */
  var $group_name = null;

  /**@var string css to style group with */
  var $group_css = null;

  /** @var string group title - used as header for group when rendering form */
  var $group_title = null;

  /** @var datetime date created */
  var $created = null;

  /** @var int id of user who created the group */
  var $created_by = null;

  /** @var string alias of created_by */
  var $created_by_alias = null;

  /** @var datetime date last modified */
  var $modified = null;

  /** @var int id of user who last modified the group */
  var $modified_by = null;

  /** @var int id of user who has the group checked out */
  var $checked_out = null;

  /** @var datetime checked out */
  var $checked_out_time = null;

  /** @var bol was the group created as part of a table join */
  var $is_join = 0;

  /** @var int state */
  var $state = null;

  /** @var string to hold the data to create $params from */
  var $attribs = null;

  /** @var int join id */
  var $join_id = null;

  /** @var object group parameters */
  var $_params = null;

  /** @var array elements in group */
  var $_aElements = null;

  /** @var int number of times the groups data has been repeated*/
  var $_repeatGroupCount = 1;

  /** @var object join */
  var $_oJoin = null;

  /** @var string join key */
  var $_joinKey = null;
  
  /** used to split repeat group (not joined though) data*/
  var $_splitter_1 = "//..*..//";

  /**
   * @param database A database connector object
   */

  function fabrikGroup( &$db )
  {
    $this->mosDBTable( '#__fabrik_groups', 'id', $db );
  }

  function getJoinKey()
  {
  	if(!isset($this->_joinKey)){
			$oJoin = $this->getJoin();
			$this->_joinKey = $oJoin->table_join_key;
  	}
    return $this->_joinKey;
  }

  /**
   * list the form id's that the group is in
   * @param bol ingore joined groups (used for check on valid element name), default false
   * @return array ints form ids
   */

  function getFormsIamIn( $ignoreJoined = false )
  {
    global $database;
    if ($ignoreJoined) {
      $sql = "SELECT form_id FROM #__fabrik_formgroup".
			"\n LEFT JOIN #__fabrik_groups".
			"\n ON #__fabrik_formgroup.group_id = #__fabrik_groups.id".
			"\n WHERE #__fabrik_formgroup.group_id = '$this->id' AND #__fabrik_groups.is_join = '0'";
    } else {
      $sql = "SELECT form_id FROM #__fabrik_formgroup WHERE group_id = '$this->id'";
    }
    $database->setQuery( $sql );
    $res = $database->loadResultArray( );
    return  $res;
  }

  /**
   * overloaded check function
   */

  function check( )
  {
    if (trim( $this->group_name ) == '') {
      $this->_error = "Your Group must contain a name.";
      return false;
    }
    return true;
  }

  /**
   * copies a group
   * @param int group id to copy
   */

  function copyRow( $id )
  {
    global $database;
    $tbl = $this->_tbl;
    $_tbl_key = $this->_tbl_key;
    $sql = "SELECT * FROM $tbl WHERE $_tbl_key = '$id'";
    $database->setQuery( $sql );
    $item = $database->loadObjectList( );
    $item = $item[0];
    if ($item->id > 0) {
      foreach ($item as $key=>$val) {
        if ($key != 	$_tbl_key) {
          $this->$key = $val;
        }
      }
    }
    $name = $this->group_name;
    if (substr( $name, 0 , 8 ) == "Copy_of_") {
      if (strrpos( $name, "-" ) > 0) {
        $tot = strrpos( $name, "-" ) - strlen( $name );
        $sName = substr( $name, 8, $tot ) ;
      } else {
        $sName = substr( $name, 8 );
      }
      $sql = "SELECT group_name FROM $tbl WHERE group_name LIKE '%$sName%'";
    } else {
      $sql = "SELECT group_name FROM $tbl WHERE group_name LIKE '%$name%'";
      $name = "Copy_of_" . $name;
    }
    $database->setQuery( $sql );
    $names = $database->loadResultArray();
    if (count($names) == 2) {
      $name = $name . "-2";
    } else if (count( $names ) > 2) {
      if (strrpos( $name, "-" ) > 0) {
        $name = substr( $name , 0, strrpos( $name, "-" )+1 ) . ( count( $names ) );
      } else {
        $name = $name . "-" . ( count( $names ) );
      }
    }
    $this->group_name = $name;
    if (!$this->check( )) {
      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
      exit();
    }
    if (!$this->store( )) {
      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
      exit();
    }
  }
   
  /**
   * returns array of elements in the group
   * @param bol if true only those elements marked as 'show_in_table_view' are returned
   * @param bol if true only those elements that are published are returned
   * @param bol if true load element validations (default true)
   * @return array element objects
   */

  function getMyElements( $tableViewOnly = false, $excludeUnpublished = true, $loadValidations = true )
  {
    global $database;
    $sql = "SELECT id FROM  #__fabrik_elements
    WHERE group_id = '$this->id' " ;
    if ($excludeUnpublished) {
      $sql .= " AND #__fabrik_elements.state = '1' ";
    }
    if ($tableViewOnly) {
      $sql .= " AND show_in_table_summary = '1' ";
    }
    $sql .= "ORDER BY ordering";
    $database->setQuery( $sql );
    $aElementIds = $database->loadResultArray();
    $aElObjs = array( );
    foreach ($aElementIds as $elId) {
      $oElement = new fabrikElement( $database );
      $oElement->load( $elId );
      if ($loadValidations) {
        $oElement->loadValidations( );
      }
      $aElObjs[ $oElement->id ] = $oElement;
    }
    $this->_aElements = $aElObjs;
    return $aElObjs;
  }

  /**
   * gets the default value for the element
   * @param object element
   * @param array posted data (overrides the elements default data )
   * @param object form
   * @param bol if true show the id if false show the label (used for advanced dataase joins)
   * @param int sub group count
   * @return string default data
   */

  function getElementDefaultValue( &$oElement, $data, &$oForm, $editable = true, $c = 0 )
  {
    global $mosConfig_absolute_path, $database, $mosConfig_offset, $_SESSION;
    $defaultVal = $oElement->default;
    //rob - if its a mambot and a validation has failed then
    //the previously submitted data is in the session
    if ($oForm->_isMambot && mosGetParam( $_POST, 'fabrik_frommodule' ) == '1') {
      $data = $_SESSION['fabrik'][$oForm->id];
    }
    if ($oElement->eval == "1") {
      $defaultVal = @eval( stripslashes($defaultVal) );
    }

    $defaultVal = htmlspecialchars( $defaultVal, ENT_QUOTES );
    if ($this->is_join) {
    $oJoin = new fabrikJoin( $this->_db );
      $oJoin->loadFromGroupId( $this->id );
      $fullName = $oJoin->table_join . $oForm->_joinTableElementStep . $oElement->element_name;
       
      if (isset( $data[$fullName] )) {
        //not suer if this is ever the case :(
        if ($c >= count( $data[$fullName] )) {
          $defaultVal = $data[$fullName][0];
        } else {
          $defaultVal = $data[$fullName][$c];
        }
      }else{
        if (array_key_exists( 'join', $data )) {
        	if (array_key_exists( $oJoin->id, $data['join'] )) {
        		$defaultVal = $data['join'][$oJoin->id][$fullName][$c];
        	}
        }
      }
    } else {
      $tableName = $oForm->getTableName();
      $fullName = $tableName . $oForm->_joinTableElementStep . $oElement->element_name;
       
      if ($this->getCanRepeatGroup()) {
        //NOT A JOIN - but a repeat group
      	$key =  (isset( $data[ $fullName ] )) ? $fullName : $oElement->element_name;
        if (array_key_exists( $key, $data )) {
          if ($oElement->elementtype_id == 8) {
            $defaultVal = $data[$key]['value'];
          } else {
            $defaultVal  = $data[$key];
            
          	if( is_string( $defaultVal ) && strstr( $defaultVal, $this->_splitter_1 )) {
				    	$bits = explode( $this->_splitter_1, $defaultVal);
				    	$defaultVal = $bits[$c];
				    }
          }
        }
      } else { //non repeat group
        if (isset( $data[ $fullName ] )) {
          /* drop down  */
          if (is_array( $data[ $fullName ] )) {

            if (isset( $data[ $fullName ]['value'] )) {
              /* if not its a file upload el */
              $defaultVal = $data[ $fullName ]['value'];
            } else {
               
              if ($oElement->elementtype_id == 3) {
                $defaultVal = implode( $this->_splitter_1, $data[ $fullName ] );
              }
            }
             
          } else {
            $defaultVal = $data[$fullName];
          }
        } else {
          if (isset( $data[$oElement->element_name] )) {
            /* drop down  */
            if (is_array( $data[ $oElement->element_name ] )) {
              if (isset( $data[ $oElement->element_name ]['value'] )) {
                /* if not its a file upload el */
                $defaultVal = $data[ $oElement->element_name ]['value'];
              }
            } else {
              $defaultVal = $data[$oElement->element_name];
            }
          }
        }
      }
    }
    /** check if its database join & that we want to show the value rather than the id*/

    /**
     * MOVED TO fabrik_html_content::getElement
     */
    if (!$editable) {
      if ($oElement->elementtype_id == "12") {
        $defaultVal = $oElement->getDatabaseDropdownDefaultValue( $defaultVal, $c );
      }
    }
    /** ensure that the data is a string **/

    if (is_array( $defaultVal )) {
      $defaultVal = implode( ',', $defaultVal );
    }
    return $defaultVal;
  }

  function getJoin(){
    if (is_null( $this->_oJoin )) {
      $this->_loadJoin();
    }
    return $this->_oJoin;
  }

  function _loadJoin(){
    global $database;
    $this->_oJoin = new fabrikJoin( $database );
    $this->_oJoin->load( $this->join_id );
  }

  /**
   * parse the record data to get only this groups join data
   * if not a group return all the data
   * @param array posted data
   * @param object form
   */

  function getActiveData( &$data, &$oForm ){
    global $database;
    $this->_repeatGroupCount = 1;
    $activeData = $data;
    $oJoin = $this->getJoin();
    $this->_joinKey = $oJoin->table_join_key;
    //need to duplicate this perhaps per the number of times that a repeat group occurs in the default data?
    if (is_array( $oForm->_joinDefaultData )) {
       
      if (array_key_exists( $oJoin->id, $oForm->_joinDefaultData )) {
        $activeData = $oForm->_joinDefaultData[$oJoin->id];
        reset($this->_aElements);
        $tmpElement = current($this->_aElements);
        $smallerElHTMLName	= $this->getElementFullName( $tmpElement, $oForm, false, true, false );
        $this->_repeatGroupCount = count($activeData[$smallerElHTMLName]);
      } else {
        //guess at how many repeated groups were posted
        $tmpElement = current($this->_aElements);
        foreach ($this->_aElements as $tmpElement) {
          if ($tmpElement->elementtype_id != 8) { //ignore fileuploads
            $smallerElHTMLName	= $this->getElementFullName( $tmpElement, $oForm, false, true, false );
            if (array_key_exists( $smallerElHTMLName, $activeData )) {
              if (is_array( $activeData[$smallerElHTMLName] )) {
            		$c = count($activeData[$smallerElHTMLName]);
              } else {
              	// @since 1.0.5.2 - udpate the _repeatGroupCount if splitter found	
              	$c = substr_count( $activeData[$smallerElHTMLName], $this->_splitter_1 ) + 1;
              }
              if ($c > $this->_repeatGroupCount ){ $this->_repeatGroupCount = $c;}
            }
          }
        }
      }
    }
    return $activeData;
  }

  /**
   * form validation add error msg
   * @param array errors
   * @param string  element name
   * @param string error message
   * @param int repeat count ref
   */
   
  function _addError(&$arErrors, $elname, $error_message, $c )
  {
    if ($this->getCanRepeatGroup()) {
      $arErrors['join'][$this->join_id][$elname][$c]= $error_message;
    } else {
      $arErrors[$elname][$c] = $error_message;
    }
  }

  /**
   * @param object element
   * @param object form
   * @param bol add join[joinid][] to element name (default true)
   * @param bol concat name with form's step element (true) or with '.' (false) default true
   * @param bol include "[]" at the end of the name (used for repeat group elements) default true
   */

  function getElementFullName( &$oElement, &$oForm, $includeJoinString = true, $useStep = true, $incRepeatGroup = true  ){
    $defaultVal = '';
    if ($useStep ) {
      $thisStep = $oForm->_joinTableElementStep;
    } else {
      $thisStep = '.';
    }
    if ($this->is_join) {
      $oJoin = new fabrikJoin( $this->_db );
      $oJoin->loadFromGroupId( $this->id );
      if ($includeJoinString) {
        $fullName = 'join[' . $oJoin->id . '][' . $oJoin->table_join . $thisStep . $oElement->element_name . ']';
      } else {
        $fullName =  $oJoin->table_join . $thisStep . $oElement->element_name ;
      }
    } else {
      $tableName = $oForm->getTableName();
      $fullName = $tableName . $thisStep . $oElement->element_name;
    }

    if ($this->getCanRepeatGroup() == 1 && $incRepeatGroup) {
      $fullName .=  "[]";
    }
    return $fullName;
  }

  /**
   * get the element name of the key element in a database join element
   * used for getting the correct name to order element joins in the table view
   * @param object element
   * @param object  form
   * @param bol prepend with  "[join][x]" if in a join
   * @param bol use "___" (true) or "." in the name
   * @param bol add "[]" to the end if in a repeat group
   */

  function getElementsJoinKeyFullName( &$oElement, &$oForm, $includeJoinString = true, $useStep = true, $incRepeatGroup = true)
  {
    $defaultVal = '';
    if ($useStep) {
      $thisStep = $oForm->_joinTableElementStep;
    } else {
      $thisStep = '.';
    }
    if ($this->is_join) {
      $oJoin = new fabrikJoin( $this->_db );
      $oJoin->loadFromGroupId( $this->id );
      if ($includeJoinString) {
        $fullName = 'join[' . $oJoin->id . '][' . $oJoin->table_join . $thisStep . $oElement->element_name . ']';
      } else {
        $fullName =  $oJoin->table_join . $thisStep . $oElement->element_name ;
      }
    } else {
      $tableName = $oElement->join_db_name;
      $fullName = $tableName . $thisStep . $oElement->element_name;
    }

    if ($this->getCanRepeatGroup() == 1 && $incRepeatGroup) {
      $fullName .=  "[]";
    }
    return $fullName;
  }

  function getCanRepeatGroup()
  {
    $this->getParams();
    return $this->_params->get( 'repeat_group_button' );
  }

  function &getParams()
  {
    if( is_null( $this->_params ) ){
      $this->_params =  new fabrikParams( $this->attribs );
    }
    return $this->_params;
  }

  /**
   * creates a html dropdown off all groups
   * @param int selected group id
   * @param bol show the group id as well
   * @return string group list
   */

  function makeDropDown( $selectedId =0, $showId = false ){
    global $database;
    if( $showId ){
      $sql = "SELECT id AS value, CONCAT(id, ': ', group_name) AS text FROM #__fabrik_groups ORDER BY group_name";
    }else{
      $sql = "SELECT id AS value, group_name AS text FROM #__fabrik_groups ORDER BY group_name";
    }
    $database->setQuery( $sql );
    $aTmp[] = mosHTML::makeOption( "-1", _PLEASE_SELECT );
    $groups = $database->loadObjectList( );
    $groups = array_merge( $aTmp, $groups );
    $list = mosHTML::selectList( $groups, 'filter_groupId', 'class="inputbox"  onchange="document.adminForm.submit( );"', 'value', 'text', $selectedId );
    return $list;
  }

  function load( $oid=null ){
    $k = $this->_tbl_key;
    if ($oid !== null) {
      $this->$k = $oid;
    }
    $oid = $this->$k;
    if ($oid === null) {
      return false;
    }

    $class_vars = get_class_vars(get_class($this));
    foreach ($class_vars as $name => $value) {
      if (($name != $k) and ($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
        $this->$name = $value;
      }
    }
    $this->reset();
    $query = "SELECT #__fabrik_groups.*, #__fabrik_joins.id AS join_id "
    . "\n FROM $this->_tbl"
    . "\n LEFT JOIN #__fabrik_joins ON #__fabrik_groups.id = #__fabrik_joins.group_id"
    . "\n WHERE #__fabrik_groups.$this->_tbl_key = " . $this->_db->Quote( $oid )
    ;
    $this->_db->setQuery( $query );
    $ok  = $this->_db->loadObject( $this );
    return $ok;
  }

}
?>