<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrikDatabase extends database{

	/**
	* Load a list of database objects
	* @param string The field name of a primary key
	* @return array If <var>key</var> is empty as sequential list of returned records.
	* If <var>key</var> is not empty then the returned array is indexed by the value
	* the database key.  Returns <var>null</var> if the query fails.
	*/
	function loadObjectListIgonreNull( $key='' ) {
		if (!($cur = $this->query())) {
			return null;
		}
		$array = array();
		while ($row = mysql_fetch_object( $cur )) {
			if ($key) {
				$array[$row->$key] = $row;
			} else {
				$array[] = $row;
			}
		}
		mysql_free_result( $cur );
		return $array;
	}
}


class fabrikDBTable extends mosDBTable {
	
	/** @var bol in admin (true) or front end (false)*/
	var $_admin = false;
	
	/** @var array list of all post data to not perform actios on*/
	var $_aDataToIgnore = array("fabrik_frommodule", "ids", "option", "act", "task", "tableid", "Itemid" , "limitstart", "pagelimit", "limit", "orderdir", "orderby", "sessioncookie", "mosadmin", "webfxtab_configPane", "webfxtab_content-pane", "PHPSESSID");

	/** @var array list of reserved words that fabrik uses - elements can't have these names*/
	var $_reservedWords = array("fabrik_frommodule", "act","task", "option", "form_id", "Submit", "ul_max_file_size", "ul_file_types", "ul_directory", "tableid", 'rowid', 'Itemid', 'fabrik', 'addDropDownValue', 'addDropDownLabel', 'ul_end_dir');

	/** @var string The null/zero date string */
	var $_nullDate		= '0000-00-00 00:00:00';
	
	/** #var bool do we want to format data in parseMessageForPlaceHolder */
	var $_format_data = false;
	
	/**
	 * requires that the child object has the corrent 'mambo' fields for
	 * publsihing - ie state, publish_up, publish_down.
	 * @return bol can show the published item or not
	 */
	 
	function canPublish(){
		global $mosConfig_offset;
		$now = date( 'Y-m-d H:i:s', time() + $mosConfig_offset * 60 * 60 );
		/* set the publish down date into the future */
		if (trim($this->publish_down) == '0000-00-00 00:00:00' || trim($this->publish_down) == '' ) { $this->publish_down = $now + 30;}
		/* set the publish up date into the past */ 
		if (trim($this->publish_up) == '0000-00-00 00:00:00' || trim($this->publish_up) == '' ) { $this->publish_up = $now - 30;} 
		if($this->state == '1' and $now >=$this->publish_up and $now <= $this->publish_down){
			return true;
		}else{
			return false;
		}
	}
	
	/**  
	 * sets the instances admin state
	 * @param bol admin state
	 */
	 
	function setAdmin( $bol ){
		$this->_admin = $bol;
	}
	
	function copyRow( $id, $updateOrderColumns ){
		global $database;
		$tbl = $this->_tbl;
		$_tbl_key = $this->_tbl_key;
		/* get the data to copy */
		$sql = "SELECT * FROM $tbl WHERE $_tbl_key = '$id'";
		$database->setQuery( $sql );
		$item = $database->loadObjectList( );
		$item = $item[0];
		/* add the data to this object as long as its not the key */
		foreach( $item as $key=>$val ){
			if ( $key != $_tbl_key ){
				$this->$key = $val;
			}
		}
		if ( !$this->check( ) ) {
			echo "<script> alert('".$this->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		if ( !$this->store() ) {
			echo "<script> alert('".$this->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		/* parse the update code to state which columns get updated */
		$updatewhere = "";
		foreach( $updateOrderColumns as $key=>$val ){
			if ( substr( $val,0,4 ) == '$row' ) { 
				/* here we replace the value with date created from the row */
			    $val = $this->$key;
			}
			$updatewhere .= " $key = '$val' AND";
		}
		/* strip the last and from the where statement */
		$updatewhere = substr( $updatewhere,0,strlen( $updatewhere )-3 );
		$this->updateOrder( $updatewhere );
	}
	
	/**
	 * tests to see if the object contains this variable, and if it does sets
	 * the value of it
	 * @param string variable name
	 * @param string variable new value
	 * @return bol true if found and set
	 */
	 
	 function setVar( $varName, $varVal ){
	 	if( isset( $this->$varName ) ){
	 		$this->$varName = $varVal;
	 		return true;
	 	} else {
	 		return false;
	 	}
	 }
	 
	/**
	 * publish unpublish stuff
	 * @param array/int ids to publish
	 * @param bol publish = true, unpublish = false
	 */
	 
	function publish( $id, $state ){
		global $database;
		if ( is_array( $id ) ){
			foreach( $id as $i ){
				$sql = "UPDATE  $this->_tbl SET state = '$state' WHERE $this->_tbl_key = '$i'";
				$database->setQuery( $sql );
				$database->query();
			}
		} else {
			$sql = "UPDATE $this->_tbl SET state = '$state' WHERE $this->_tbl_key = '$id'";
			$database->setQuery( $sql );
			$database->query( );			
		}
	}
	
	function tableExists($table){
		global $database;
		$sql = "SHOW TABLES";
		$database->setQuery($sql);
		$rows = $database->loadAssocList();
		if(in_array($table, $rows)){
			return true;
		}else{
			return false;
		}
	}

	/**
	 * Link the object item to a menu
	  * @param string fabrik action
	  * @param string fabrik data to passwith action
	 */
	
	function menuLink( $linkact = 'viewTable', $linkData = 'tableid=0') {
		global $database;
		$menu = mosGetParam($_POST, 'menuselect', '');
		$link = mosGetParam($_POST, 'link_name', '');
		$row = new mosMenu($database);
		$row->menutype = $menu;
		$row->name = $link;
		/* was url but this doesnt work with dyamic template swapping on link */
		$row->type = 'components'; 
		$row->published = 1;
		$row->link = "index.php?option=com_fabrik";
		$sql = "SELECT id FROM #__components WHERE `option` = 'com_fabrik' AND link <> '' AND link IS NOT NULL";
		$database->setQuery( $sql );
		$componentId = $database->loadResult();
		$row->componentid = $componentId;
		$row->params = "task=$linkact
						$linkData";
		$row->ordering = 9999;
		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}
		$row->checkin();
		$row->updateOrder("menutype='$row->menutype' ");
		$msg = $link.' (Link - Static Content) in menu: '.$menu.' successfully created';
		return $msg;
	}	
	
	/**
	 * gets the primary key for a given table
	 * @param string table name
	 * @return string tables primary key field name
	 */
	 
	function getPrimaryKey( $table ){
		global $database;
		$database->setQuery( "DESCRIBE $table" );
		$fields = $database->loadObjectList( );
		if ( is_array( $fields ) ){
			foreach( $fields as $field ){
				if( $field->Key == 'PRI' ){
					return $field->Field;
				}
			}
		}
		return '';
	}
	
	/**
	 * iterates through string to replace every
	 * {placeholder} with posted data
	 * @param string text to parse
	 * @param bool format data for message body
	 */
	 
	function parseMessageForPlaceHolder( $msg, $format_data = false ){
		/** $$$ hugh - added $format_data, so we can format things like
		 * repeat group data if this is a message body
		 */
		$this->_format_data = $format_data;
		$msg = $this->_replaceWithUserData( $msg );
		$msg = $this->_replaceWithGlobals( $msg );
		$msg = preg_replace( "/{}/", "", $msg ); 
		/* replace {element name} with form data */
		$msg = preg_replace_callback( "/{[^}]+}/i", array($this,'_replaceWithFormData'), $msg ); 
		return $msg;
	}
	
	/**
	 * PRIVATE:
	 * called from parseMessageForPlaceHolder to iterate through string to replace
	 * {placeholder} with user ($my) data
	 * @param string message to parse
	 * @return string parsed message
	 */
	
	function _replaceWithUserData( $msg ){
		global $my;
		if($my){
			foreach($my as $key=>$val){
				if(substr($key, 0, 1) != '_'){
					if(!is_object($val)){
						// both urlencoded and normal text can arrive here hence test for both
						$msg = str_replace('{$my-&gt;' . $key . '}', $val, $msg);
						$msg = str_replace('{$my->' . $key . '}', $val, $msg);
					}
				}
			}
		}
		return $msg;		
	}
	
	/**
	 * PRIVATE:
	 * called from parseMessageForPlaceHolder to iterate through string to replace
	 * {placeholder} with global data
	 * @param string message to parse
	 * @return string parsed message
	 */
	
	function _replaceWithGlobals( $msg ){
		global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_offset, $Itemid, $mosConfig_sitename, $my, $mosConfig_mailfrom;
		$msg = str_replace('{$mosConfig_absolute_path}', $mosConfig_absolute_path, $msg);
		$msg = str_replace('{$mosConfig_live_site}', $mosConfig_live_site, $msg);
		$msg = str_replace('{$mosConfig_offset}', $mosConfig_offset, $msg);
		$msg = str_replace('{$Itemid}', $Itemid, $msg);
		$msg = str_replace('{$mosConfig_sitename}', $mosConfig_sitename, $msg);
		$msg = str_replace('{$mosConfig_mailfrom}', $mosConfig_mailfrom, $msg);
		foreach ($_SERVER as $key=>$val) {
			if (is_string($val)) {
				$msg = str_replace('{'.$key.'}', $val, $msg);
			}	
		}
		return $msg;		
	}	
	
	/**
	 * PRVIATE:
	 * called from parseMessageForPlaceHolder to iterate through string to replace
	 * {placeholder} with posted data
	 * @param string placeholder e.g. {placeholder}
	 * @return string posted data that corresponds with placeholder
	 */
	 
	function _replaceWithFormData( $matches ){
		global $my;
		if( isset( $this->_data ) ){
			$data = $this->_data;
		}else{
			$data = $_REQUEST;
		}
		$match = $matches[0];
		/* strip the {} */
		$match = substr( $match, 1, strlen($match) - 2 ); 

		$match = strtolower( $match ); 		
		// $$$ hugh - allow use of {$rowpk} or {rowpk} to mean the rowid of the rwo within a table
		if ($match == 'rowpk' or $match == '$rowpk')
		{
			$match = $this->_table->db_primary_key;
			$match = preg_replace('#^(\w+\.)#','',$match);
		}
		$match = preg_replace( "/ /", "_", $match );
		
		/* $$$ hugh - adding match_key stuff */
		$match_matches = array();
		$match_key = '';
		if (preg_match('#(\S+)\[(\d+)\]$#',$match,$match_matches)) {
			$match = $match_matches[1];
			$match_key = $match_matches[2];
		}
		if ( !strstr( $match, "." ) ) {
			 /* for some reason array_key_exists wasnt working for nested arrays?? */
			$aKeys = array_keys( $data );
			/* remove the table prefix from the post key */
			$aPrefixFields = array();
			for($i=0;$i<count($aKeys);$i++){
				$aKeyParts = explode( '___', $aKeys[$i]);
				if(count($aKeyParts) == 2){
					$tablePrefix = array_shift($aKeyParts);
					$field = array_pop($aKeyParts);
					$aPrefixFields[$field] = $tablePrefix;
				}
			}
			if( array_key_exists( $match, $aPrefixFields)){
				$match =  $aPrefixFields[$match] . '___' . $match;
			}
			if( in_array( $match, $aKeys ) ) {	
				/* get the post data */
				if (is_array($data[$match]) and $match_key != '') {
					$match = $data[ $match][ $match_key ];
				}
				else {
					$match = $data[ $match ];
				}
				if( is_array( $match ) ){
					/** $$$ hugh - need something here to format repeat group
					 * data in mail onto separate lines.
					 */
					if ($this->_format_data) {
						$match = implode( '<br />', $match);
					}
					else {
						$match = implode( ',', $match);
					}
				}
			} else {
				$match = "";
			}
		} else {
			/* could be looking for URL field type eg for $_POST[url][link] the match text will be url.link */
			$aMatch = explode( ".", $match );
			$aPost = $data;
			foreach( $aMatch as $sPossibleArrayKey ){
				if ( is_array( $aPost ) ){
					if ( !isset( $aPost[$sPossibleArrayKey] ) )	{
						$match = "";
						return $match;
					} else {
						$aPost = $aPost[$sPossibleArrayKey];
					}
				}
			}
			$match = $aPost;
			return $match;	
		}
		return $match;
	}
	
	/**
	 * recursive file name incrementation untill no file with exsiting name
	 * exists
	 * @param string intial file name
	 * @param string this recursions file name
	 * @param int file version
	 * @return string new file name
	 */
	 
	function incrementFileName( $origFileName, $newFileName, $version ){
		if( file_exists( $newFileName ) ){
			$orig_f_ext = substr( $origFileName, -4 );
			$orig_f_name = substr( $origFileName, 0, strlen($origFileName)-4 );
			$newFileName = $orig_f_name . $version . $orig_f_ext;
			$version ++;
			$newFileName = $this->incrementFileName( $origFileName, $newFileName, $version );
		}	
		return $newFileName;	
	} 
	
  function replace_num_entity($ord){
       $ord = $ord[1];
       if ( preg_match('/^x([0-9a-f]+)$/i', $ord, $match ) ){
           $ord = hexdec($match[1]);
       } else {
           $ord = intval($ord);
       }
       $no_bytes = 0;
       $byte = array();
       if ($ord < 128) {
           return chr($ord);
       }
       elseif ($ord < 2048)
       {
           $no_bytes = 2;
       }
       elseif ($ord < 65536)
       {
           $no_bytes = 3;
       }
       elseif ($ord < 1114112)
       {
           $no_bytes = 4;
       }
       else
       {
           return;
       }

       switch($no_bytes)
       {
           case 2:
           {
               $prefix = array(31, 192);
               break;
           }
           case 3:
           {
               $prefix = array(15, 224);
               break;
           }
           case 4:
           {
               $prefix = array(7, 240);
           }
       }
       for ($i = 0; $i < $no_bytes; $i++) {
           $byte[$no_bytes - $i - 1] = (($ord & (63 * pow(2, 6 * $i))) / pow(2, 6 * $i)) & 63 | 128;
       }
       $byte[0] = ($byte[0] & $prefix[0]) | $prefix[1];
       $ret = '';
       for ($i = 0; $i < $no_bytes; $i++) {
           $ret .= chr($byte[$i]);
       }
       return $ret;
   }
   
	/**
	 * adds an forward slash to end of string if one is not already there
	 *@param string to add end slash to 
	 */
	 
	 function addEndSlash($str){
	 	if(!$this->endsWith( $str, "/" )){
	 		$str .= "/";
	 	}
	 	return $str;	
	 }
	 
	 function endsWith( $str, $lastChar ){
	 	if( substr( $str, strlen($str)-1, 1) == $lastChar ){
	 		return true;	
	 	}
	 	return false;
	 }
	 
	 /**
	  * when objs are saved we convert the params data into the attribs field
	  * @param array parameters to save
	  * @param array elements to not encode (not yet implemented)
	  */
	 
	 function updateAttribsFromParams( $params, $aDontEncode = array() ){
		$oFabrikParams = new fabrikParams('','');
	 	if ( is_array( $params ) ) {
			$txt = array();
			foreach ( $params as $k => $v ) {
				$deep = 0;
				if( is_array( $v ) ){
					$str = '';
					foreach( $v as $key2=>$val2 ){
						if( is_array( $val2 ) ){
							foreach( $val2 as $key3 => $val3 ){
								$deep = 1;
								$str .= $val3 . $oFabrikParams->_splitter_2;	
							}
							$str =  substr($str, 0, - strlen($oFabrikParams->_splitter_2)) . $oFabrikParams->_splitter_1;  
						}else{
							$str .= "$val2" . $oFabrikParams->_splitter_1;
						}
					}
					$v =  substr($str, 0, - strlen($oFabrikParams->_splitter_1));  
				}
				if($deep){
					$v = $oFabrikParams->_splitter_1 . $v . $oFabrikParams->_splitter_1;	
				}
				$v = str_replace( "\n", "", $v );
				if (get_magic_quotes_gpc()) {
					$v = stripslashes( $v );
				}
				$txt[] = "$k=$v";
			}
			$this->attribs = implode( "\n", $txt );
		}
		return $this->attribs;
	 }
	 
	 /**
	  * required for compatibility with mambo 4.5.4
	  */
	  
  	function getNullDate() {
		return $this->_nullDate;
	}
	
	function reset( $value=null ) {
		$keys = $this->getPublicProperties();
		foreach ($keys as $k) {
			$this->$k = $value;
		}
	}
	
		/**
	 * Returns an array of public properties
	 * @return array
	 */
	function getPublicProperties() {
		static $cache = null;
		if (is_null( $cache )) {
			$cache = array();
			foreach (get_class_vars( get_class( $this ) ) as $key=>$val) {
				if (substr( $key, 0, 1 ) != '_') {
					$cache[] = $key;
				}
			}
		}
		return $cache;
	}
}


class FastJSON {

	// public methods

	/**
	 * public static method
	 *
	 *	FastJSON::convert(params:* [, result:Instance]):*
	 *
	 * @param	*		String or Object
	 * @param	Instance	optional new generic class instance if first
	 *				parameter is an object.
	 * @return	*		time() value or new Instance with object parameters.
	 *
	 * @note	please read Special FastJSON::convert method Informations
	 */
	function convert($params, $result = null){
		switch(gettype($params)){
			case	'array':
				$tmp = array();
				foreach($params as $key => $value) {
					if(($value = FastJSON::encode($value)) !== '')
					array_push($tmp, FastJSON::encode(strval($key)).':'.$value);
				};
				$result = '{'.implode(',', $tmp).'}';
				break;
			case	'boolean':
				$result = $params ? 'true' : 'false';
				break;
			case	'double':
			case	'float':
			case	'integer':
				$result = $result !== null ? strftime('%Y-%m-%dT%H:%M:%S', $params) : strval($params);
				break;
			case	'NULL':
				$result = 'null';
				break;
			case	'string':
				$i = create_function('&$e, $p, $l', 'return intval(substr($e, $p, $l));');
				if(preg_match('/^[0-9]{4}\-[0-9]{2}\-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}$/', $params))
				$result = mktime($i($params, 11, 2), $i($params, 14, 2), $i($params, 17, 2), $i($params, 5, 2), $i($params, 9, 2), $i($params, 0, 4));
				break;
			case	'object':
				$tmp = array();
				if(is_object($result)) {
					foreach($params as $key => $value)
					$result->$key = $value;
				} else {
					$result = get_object_vars($params);
					foreach($result as $key => $value) {
						if(($value = FastJSON::encode($value)) !== '')
						array_push($tmp, FastJSON::encode($key).':'.$value);
					};
					$result = '{'.implode(',', $tmp).'}';
				}
				break;
		}
		return $result;
	}

	/**
	 * public method
	 *
	 *	FastJSON::decode(params:String[, useStdClass:Boolean]):*
	 *
	 * @param	String	valid JSON encoded string
	 * @param	Bolean	uses stdClass instead of associative array if params contains objects (default false)
	 * @return	*	converted variable or null
	 *				is params is not a JSON compatible string.
	 * @note	This method works in an optimist way. If JSON string is not valid
	 * 		the code execution will die using exit.
	 *		This is probably not so good but JSON is often used combined with
	 *		XMLHttpRequest then I suppose that's better more protection than
	 *		just some WARNING.
	 *		With every kind of valid JSON string the old error_reporting level
	 *		and the old error_handler will be restored.
	 *
	 * @example
	 *		FastJSON::decode('{"param":"value"}'); // associative array
	 *		FastJSON::decode('{"param":"value"}', true); // stdClass
	 *		FastJSON::decode('["one",two,true,false,null,{},[1,2]]'); // array
	 */
	function decode($encode, $stdClass = false){
		$pos = 0;
		$slen = is_string($encode) ? strlen($encode) : null;
		if($slen !== null) {
			$error = error_reporting(0);
			set_error_handler(array('FastJSON', '__exit'));
			$result = FastJSON::__decode($encode, $pos, $slen, $stdClass);
			error_reporting($error);
			restore_error_handler();
		}
		else
		$result = null;
		return $result;
	}

	/**
	 * public method
	 *
	 *	FastJSON::encode(params:*):String
	 *
	 * @param	*		Array, Boolean, Float, Int, Object, String or NULL variable.
	 * @return	String		JSON genric object rappresentation
	 *				or empty string if param is not compatible.
	 *
	 * @example
	 *		FastJSON::encode(array(1,"two")); // '[1,"two"]'
	 *
	 *		$obj = new MyClass();
	 *		obj->param = "value";
	 *		obj->param2 = "value2";
	 *		FastJSON::encode(obj); // '{"param":"value","param2":"value2"}'
	 */
	function encode($decode){
		$result = '';
		switch(gettype($decode)){
			case	'array':
				
				if(!count($decode) || array_keys($decode) === range(0, count($decode) - 1)) {
					$keys = array();
					foreach($decode as $value) {
						if(($value = FastJSON::encode($value)) !== '')
						array_push($keys, $value);
					}
					$result = '['.implode(',', $keys).']';
				}
				else
				$result = FastJSON::convert($decode);
				break;
			case	'string':
				$replacement = FastJSON::__getStaticReplacement();
				$result = '"'.str_replace($replacement['find'], $replacement['replace'], $decode).'"';
				break;
			default:
				if(!is_callable($decode))
				$result = FastJSON::convert($decode);
				break;
		}
		return $result;
	}

	// private methods, uncommented, sorry
	function __getStaticReplacement(){
		static $replacement = array('find'=>array(), 'replace'=>array());
		if($replacement['find'] == array()) {
			foreach(array_merge(range(0, 7), array(11), range(14, 31)) as $v) {
				$replacement['find'][] = chr($v);
				$replacement['replace'][] = "\\u00".sprintf("%02x", $v);
			}
			$replacement['find'] = array_merge(array(chr(0x5c), chr(0x2F), chr(0x22), chr(0x0d), chr(0x0c), chr(0x0a), chr(0x09), chr(0x08)), $replacement['find']);
			$replacement['replace'] = array_merge(array('\\\\', '\\/', '\\"', '\r', '\f', '\n', '\t', '\b'), $replacement['replace']);
		}	
		return $replacement;
	}
	function __decode(&$encode, &$pos, &$slen, &$stdClass){
		switch($encode{$pos}) {
			case 't':
				$result = true;
				$pos += 4;
				break;
			case 'f':
				$result = false;
				$pos += 5;
				break;
			case 'n':
				$result = null;
				$pos += 4;
				break;
			case '[':
				$result = array();
				++$pos;
				while($encode{$pos} !== ']') {
					array_push($result, FastJSON::__decode($encode, $pos, $slen, $stdClass));
					if($encode{$pos} === ',')
						++$pos;
				}
				++$pos;
				break;
			case '{':
				$result = $stdClass ? new stdClass : array();
				++$pos;
				while($encode{$pos} !== '}') {
					$tmp = FastJSON::__decodeString($encode, $pos);
					++$pos;
					if($stdClass)
						$result->$tmp = FastJSON::__decode($encode, $pos, $slen, $stdClass);
					else
						$result[$tmp] = FastJSON::__decode($encode, $pos, $slen, $stdClass);
					if($encode{$pos} === ',')
						++$pos;
				}
				++$pos;
				break;
			case '"':
				switch($encode{++$pos}) {
					case '"':
						$result = "";
						break;
					default:
						$result = FastJSON::__decodeString($encode, $pos);
						break;
				}
				++$pos;
				break;
			default:
				$tmp = '';
				preg_replace('/^(\-)?([0-9]+)(\.[0-9]+)?([eE]\+[0-9]+)?/e', '$tmp = "\\1\\2\\3\\4"', substr($encode, $pos));
				if($tmp !== '') {
					$pos += strlen($tmp);
					$nint = intval($tmp);
					$nfloat = floatval($tmp);
					$result = $nfloat == $nint ? $nint : $nfloat;
				}
				break;
		}
		return $result;
	}
	function __decodeString(&$encode, &$pos) {
		$replacement = FastJSON::__getStaticReplacement();
		$endString = FastJSON::__endString($encode, $pos, $pos);
		$result = str_replace($replacement['replace'], $replacement['find'], substr($encode, $pos, $endString));
		$pos += $endString;
		return $result;
	}
	function __endString(&$encode, $position, &$pos) {
		do {
			$position = strpos($encode, '"', $position + 1);
		}while($position !== false && FastJSON::__slashedChar($encode, $position - 1));
		if($position === false)
			trigger_error('', E_USER_WARNING);
		return $position - $pos;
	}
	function __exit($str, $a, $b) {
		exit($a.'FATAL: FastJSON decode method failure [malicious or incorrect JSON string]');
	}
	function __slashedChar(&$encode, $position) {
		$pos = 0;
		while($encode{$position--} === '\\')
			$pos++;
		return $pos % 2;
	}
}
?>