<?php
/**
* @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
* @package Joomla
* @subpackage FAbrik
* @copyright Copyright (C) 2005 Rob Clayburn. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
 * Version information
 * @package Joomla
 */
class fabrikVersion extends joomlaVersion {
	/** @var string Product */
	var $PRODUCT 	= 'Fabrik';
	/** @var int Main Release Level */
	var $RELEASE 	= '1.0';
	/** @var string Development Status */
	var $DEV_STATUS = 'Stable';
	/** @var int Sub Release Level */
	var $DEV_LEVEL 	= '6';
	/** @var int build Number */
	var $BUILD = '$Revision: 990$';
	/** @var string Date */
	var $RELDATE 	= '28 July 2008';
	/** @var string Time */
	var $RELTIME 	= '19:00';
	/** @var string Timezone */
	var $RELTZ 		= 'GMT';
	/** @var string Copyright Text */
	var $COPYRIGHT 	= "Copyright (C) 2005 - 2007 Pollen 8 Design Ltd. All rights reserved.";
	/** @var string URL */
	var $URL 		= '<a href="http://www.fabrikar.com">Farbik</a> is Free Software released under the GNU/GPL License.';

	/** last svn commit downloaded by the user 
	NOTE to devs you have to manually update this file on each commit
	*/
	var $SVNREV = 898;

	/**
	 * codename ***/
  var $CODENAME = 'wool';
		
	var $headers = array(
		'acc'  => 'Accept: %s',
		'cont' => 'Content-Type: %s'
	);

	function construct_headers($request)
	{
		return array(
			sprintf($this->headers['acc'],  $this->config['response_type']),
			sprintf($this->headers['cont'], $this->config['response_type'])				
		);
	}
	/**
	 * calls the unfuddle api to get the latest svn revision and compares it to the rev
	 * listed in this class 
	 */

	function checkRevision()
	{
		global $mosConfig_absolute_path;
	  if (!function_exists( 'curl_init' )) {
			echo "sorry you need the curl extension to check revision ";
			return false;
		}

		$this->config = array(
			'port'             => 80,
			'version'          => 1,
			'account'          => 'account_identifier',
			'response_type'    => 'application/xml',
			'username'         => 'anonymous',
			'password'         => 'anonymous',
			'project'			=> 7429,
			'default_assignee' => 8527,
			'default_milestone' => 0
		);
		
		$headers = array(
			'Content-Type: application/xml',
			'Accept: application/xml'
		);
		$headers = $this->construct_headers('');		
			
		$url = "http://fabrik.unfuddle.com/api/v1/projects/7429/changesets/latest";
		
		$this->connection = curl_init($url);
		
		$xml_string = '';
		$curl_options = array(
			CURLOPT_URL            => $url,
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_VERBOSE => 1,
			CURLOPT_HTTPHEADER     => $headers,
			CURLOPT_SSL_VERIFYHOST => 0,
			CURLOPT_SSL_VERIFYPEER => 0,
			CURLOPT_USERPWD        => 'anonymous:anonymous'
		);
		
		foreach ($curl_options as $key => $value)
		{
			curl_setopt($this->connection, $key, $value);
		}
		?>
		<style type="text/css">
		#fabrikversion p{padding:5px;}
		#fabrikversion table{
		width:400px;
		padding:5px;margin:5px;border:1px solid #666666;
		}
		#fabrikversion table td{
		padding:5px;
		}
		</style>
		<?php
		$xml = $this->handle_response(curl_exec($this->connection));
		//echo $xml;
		require_once( $mosConfig_absolute_path . "/includes/domit/xml_domit_lite_parser.php");
		$xmlDoc = new DOMIT_Lite_Document();
		echo "<div id='fabrikversion'>";
		$ok = $xmlDoc->parseXML( $xml );
		echo "<h2>" . $this->getLongVersion() . "</h2>";
		if($ok ){
		 echo "<p style='color:green;padding:4px;'>Version info obtained from SVN server</p>";
		  $rev = $xmlDoc->getElementsByTagName('revision');
		  $rev = $rev->item(0);
		  $lastestRev = $rev->getText();
		  if( $this->SVNREV < $lastestRev ){
		  	echo "<p style='color:orange;padding:4px;'>An update is available from the SVN</p>";
		  } else {
		  	echo "<p style='color:green;padding:4px;'>Looks like you have the latest SVN revision</p>";
		  }
		  echo "<h3>last commit</h3>";
		  echo "<table><tr><th>Date</th><th>Comment</th>";
		  //if( $this->SVNREV != $lastestRev ){
		    
		    $msg = $xmlDoc->getElementsByTagName('message');
		    $c = count($msg);
		    for($x=0;$x<$c;$x++){
			    $msg = $msg->item($x);
			    $date = $xmlDoc->getElementsByTagName('created-at');
			    $date = $date->item($x);
			    echo "<tr><td>" . $date->getText() . "</td><td>" . $msg->getText() . "</td></tr>";
		    }
		  //}
		  echo "</table>";
		  echo "<h3>version info</h3>";
		  echo "<table><tr><th>Version</th><th>Revision</th></tr>";
		  echo "<tr><td>".$this->getShortVersion() . " stable SVN release revision</td><td>".$this->getReleaseSVNVersion()."<td></tr>
		  <tr><td>Your SVN revision<br /><small>(NB: manaully updated by coder in version.php so may not be up to date)</small></td><td>$this->SVNREV<td></tr>
		    <tr><td>Latest available SVN rev</td><td>$lastestRev<td></tr>";
		    echo "</table>";
		}else{
		  echo "<p style='color:red;padding:4px;'>Unable to parse reseponse</p>";
		}
		echo "</div>";
	}
	/**
	 * query the fabrik site db to get this versions svn revision number 
	 *
	 */
	function getReleaseSVNVersion()
	{
	  $url = "http://fabrikar.com/index2.php?option=com_version&no_html=1&release=".$this->RELEASE."&devlevel=".$this->DEV_LEVEL;
	  $this->connection = curl_init($url);
	  $curl_options = array(
			CURLOPT_URL            => $url,
			CURLOPT_POST => 1,
			CURLOPT_RETURNTRANSFER => 1
		);
		
		foreach ($curl_options as $key => $value)
		{
			curl_setopt($this->connection, $key, $value);
		}
		$response = curl_exec( $this->connection );
		curl_close($this->connection);
		return $response;
	}
	
	function handle_response($response, $post = false)
	{
		if (false)
		{
			header('Content-Type: text/xml');
			die($response);
		}
		
		if (curl_errno($this->connection))
		{
			die("ERROR: " . curl_error($this->connection));
		}
		curl_close($this->connection);
		
		if ($post)
		{
			return true;
		}
		if (!strstr( "{", $response )) {
			return $response;
		} else {
			return FastJSON::decode( $response );
		}
	}

	/**
	 * @return string Long format version
	 */
	function getLongVersion() {
		return $this->PRODUCT .' '. $this->RELEASE .'.'. $this->DEV_LEVEL .' '
			. $this->DEV_STATUS
			.' [ '.$this->CODENAME .' ] '. $this->RELDATE .' '
			. $this->RELTIME .' '. $this->RELTZ;
	}

	/**
	 * @return string Short version format
	 */
	function getShortVersion() {
		return $this->RELEASE .'.'. $this->DEV_LEVEL;
	}

	/**
	 * @return string Version suffix for help files
	 */
	function getHelpVersion() {
		if ($this->RELEASE > '1.0') {
			return '.' . str_replace( '.', '', $this->RELEASE );
		} else {
			return '';
		}
	}
}
$_FABRIK_VERSION = new fabrikVersion();


?>
