<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class html_connection_content {
	
	/**
	 * show a list of all the connections
	 * @param array of connection objects
	 * @param object page navigation
	 * @param string message
	 */

	function displayConnections( $rows, $pageNav, $msg ) {
		global $_VERSION, $my;
		?>
		<h1 class="sectionname"><?php echo _VIEWCONN_HEADING; ?></h1>
		<?php if($msg != ""){echo "<p><strong>$msg</strong></p>";}?> 
		<form action="index2.php" method="post" name="adminForm"> 
		<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist"> 
			<thead>
			<tr>
				<th width="1%" class="title" > 
					<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $rows );?>);" />
				</th>
				<th class="title" width="1%" >&nbsp;</th>
				<th class="title" width="29%" align="center"><?php echo _VIEWCONN_DESC; ?></th>
				<th class="title" width="25%" align="center"><?php echo _VIEWCONN_HOST; ?></th>
				<th class="title" width="5%" align ="center"><?php echo _PUBLISHED; ?></th>
				<th class="title" width="20%" ><?php echo _VIEWCONN_DATABASE; ?></th>
				<th class="title" width="20%" ><?php echo _TEST_CONNECTION; ?></th>
			</tr>
			</thead> 
			<?php
		$k = 0;
		for ( $i = 0, $n = count($rows); $i < $n; $i ++ ) {
			$row = & $rows[$i];
			$checked = fabrikCommonHTML::CheckedOutProcessing( $row, $i );
			$link 	= 'index2.php?option=com_fabrik&amp;task=editConnection&amp;hidemainmenu=1&amp;cid[]='. $row->id;
			?> 
			<tr class="<?php echo "row$k"; ?>">
				<td width="1%"><?php echo $checked;?></td>
				<td width="1%"><?php echo $row->id; ?></td>
				<td width="29%">
					<?php
					if ( $row->checked_out && ( $row->checked_out != $my->id )) {
						echo $row->description;
					} else {
					?>
						<a href="<?php echo $link; ?>" >
						<?php 
						echo $row->description; 
					}
					?>
					</a>
				</td>
				<td width="25%">
					<?php echo $row->host; ?>
				</td>
				<td>
					<?php
					if ($row->state == "1") {
						$img = 'publish_g.png';
						$alt = 'Published';
					} else {
						$img = "publish_x.png";
						$alt = 'Unpublished';
					}
					$times = '';
					if ( isset( $row->publish_up ) ) {
						if ( $row->publish_up == '0000-00-00 00:00:00' ) {
							$times .= "<tr><td>Start: Always</td></tr>";
						} else {
							$times .= "<tr><td>Start: $row->publish_up</td></tr>";
						}
					}
					
					if ( isset( $row->publish_down ) ) {
						if ($row->publish_down == '0000-00-00 00:00:00') {
							$times .= "<tr><td>Finish: No Expiry</td></tr>";
						} else {
							$times .= "<tr><td>Finish: $row->publish_down</td></tr>";
						}
					}
					?>
					<span class="hasTip" title="<?php echo 'Publish Information';?>::<?php echo $times; ?>">
						<a href="javascript:void(0);" onclick="return listItemTask('cb<?php echo $i;?>','<?php echo $row->state ? 'unpublishConnection' : 'publishConnection' ?>')">
						<img src="images/<?php echo $img;?>" border="0" alt="<?php echo $alt; ?>" />
						</a>
					</span>
									
				</td>
				<td width="20%" >
					<?php echo $row->database; ?>
				</td>		
				<td width="20%" >
					<a href="#edit" onclick="return listItemTask('cb<?php echo $i; ?>','testConnection')">
						<?php echo _TEST_CONNECTION ; ?>
					</a>
				</td>						
			</tr> 
			<?php
			$k = 1 - $k;
		} 
		?> 
			<tfoot>
				<td colspan="7">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tfoot>
		</table>
		<input type="hidden" name="option" value="com_fabrik" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="task" value="connections" />
		<input type="hidden" name="hidemainmenu" value="0" />
		<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
	</form>		
	<?php
	}

	/** 
	 * edits a database connection
	 * @param object connection
	 */
	 
	function editConnection( $row ) {
		 ?> 
		<h1 class="sectionname">
		<?php
		echo $row->id ? _EDIT : _ADD;
		echo _ADD_CONNECTION_TITLE;
		?>
		</h1>
		<?php
		if($row->default_cnn == 1){
			global $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db;
		    $row->host = $mosConfig_host;
		    $row->user = $mosConfig_user;
		    $row->password = $mosConfig_password;
		    $row->database = $mosConfig_db;
		    echo "<strong>This is the default database, details are taken from Joomla&apos;s configuration.php file</strong>";
		}
		?>
		<form action="index2.php" method="post" name="adminForm"> 
		<table cellpadding="4" cellspacing="0" border="0" width="100%"  class="adminform"> 
		<tr><th colspan="2"><?php echo _DETAILS; ?></th></tr>
			<tr>
				<td><?php echo _VIEWCONN_DESC; ?></td>
				<td><input class="inputbox" type="text" name="description" size="75" value="<?php echo $row->description; ?>" /></td>
			</tr>
			<tr>
				<td><?php echo _VIEWCONN_HOST; ?></td>
				<td><input class="inputbox" type="text" name="host" size="75" value="<?php echo $row->host; ?>" /></td>
			</tr>
			<tr>
				<td><?php echo _VIEWCONN_DATABASE; ?></td>
				<td><input class="inputbox" type="text" name="database" size="75" value="<?php echo $row->database; ?>" /></td>
			</tr> 
			<tr>
				<td><?php echo _ADD_CONN_USER; ?></td>
				<td><input class="inputbox" type="text" name="user" size="75" value="<?php echo $row->user; ?>" /></td>
			</tr>
			<?php if ($row->host != ""){?>
				<tr>
				<td><?php echo _ADD_CONN_CHANGE_PASSWORD;  ?></td>
				<td></td>
			</tr>	
			<?php } ?>		
			<tr>
				<td><?php echo _ADD_CONN_PASSWORD; ?></td>
				<td><input class="inputbox" type="password" name="password" size="20" value="<?php echo $row->password; ?>" /></td>
			</tr>
			<tr>
				<td><?php echo _ADD_CONN_PASSWORD_CONF; ?></td>
				<td><input class="inputbox" type="password" name="passwordConf" size="20" value="<?php echo $row->password; ?>" /></td>
			</tr>			
			<tr>
				<td><label for="state"><?php echo _PUBLISHED; ?></label></td>
				<td>
					<input type="checkbox" name="state" id="state" value="1" <?php echo $row->state ? 'checked="checked"' : ''; ?> />
				</td>
			</tr>						
		</table>
		<input type="hidden" name="option" value="com_fabrik" /> 
		<input type="hidden" name="task" value="saveConnection" /> 
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
	</form>
<?php
 }
}
?>